local mission_won=false
local mission_lost=false
local goala=false
local goalb=false
local goalc=false
local startup_done=false
local camera1=false
local camera2=false
local camera3=false
local camera4=false
local apcsound=false
--local last_wave_time=99999.0
--local wave_timer=0.0
--local cam_time=0.0
--local NextSecond=99999.0
local madison=nil
local outpost=nil
local ccarecy=nil
local ccafact=nil
local player=nil
local nav=nil
local star=nil
local star2=nil
local star3=nil
local tank=nil
local audmsg=0

function Save()
	return 
		-- bools
		mission_won,mission_lost,goala,goalb,goalc,startup_done,camera1,camera2,camera3,camera4,apcsound,
		-- floats
		
		-- handles
		madison,outpost,ccarecy,player,ccafact,nav,star,star2,star3,tank,
		-- ints
		audmsg
end

function Load(...)
	if select('#', ...) > 0 then
		-- bools
		mission_won,mission_lost,goala,goalb,goalc,startup_done,camera1,camera2,camera3,camera4,apcsound,
		-- floats
		
		-- handles
		madison,outpost,ccarecy,player,ccafact,nav,star,star2,star3,tank,
		-- ints
		audmsg
		= ...
	end
end

function PostLoad()
end


function Update ()
    
    --From Goomba's "template" not sure if it works correctly
    --Ally(3, 4) --This allies team 3 and 4, use this to ally two AI teams.
    SetAIP("omegam01.aip", 2) --sets the AIP file for team 3.
    --SetAIP("mpi1sov.aip", 4) --This sets the AIP file for team 4.
    --SetPilot (2, 20) --This gives team 3 20 pilots.
    --SetScrap (2, 50) --This gives team 3 50 scrap.
    --SetPilot (4, 20) --This gives team 4 20 pilots.
    --SetScrap (4, 50) --This gives team 3 50 scrap.
    
	player = GetPlayerHandle()
	madison = GetHandle("avmuf78_factory")
    outpost = GetHandle("abmbld22_supplydepot")
	ccarecy = GetHandle("svrecy46_recycler")
	ccafact = GetHandle("svmuf46_factory")
	nav = GetHandle("apcamr49_camerapod")
	star = GetHandle("avfigh10_wingman")
	star2 = GetHandle("svhraz393_wingman")
	star3 = GetHandle("abbarr5_barracks")
	tank = GetHandle("avtank8_wingman")
	
	
	
	if not startup_done then
        startup_done = true
        camera1=true
        CameraReady()
        audmsg = AudioMessage("spacer8.wav")
    end
    
    if camera1 then
		if CameraPath("camera1",1200,1550,star) or CameraCancelled() or IsAudioMessageDone(audmsg) then
			camera1 = false
			camera2 = true
			audmsg = AudioMessage("spacer8.wav")
		end
	end
	
	if camera2 then
		if CameraObject(star2,500,1000,2000,star2) or CameraCancelled() or IsAudioMessageDone(audmsg) then
			camera2 = false
			camera3 = true
			BuildObject("aspilo",1,"pilot_spawn")
			audmsg = AudioMessage("space5.wav")
		end
	end
			
	if camera3 then
		if CameraPath("camera3",300,300,star3) or CameraCancelled() then
			camera3 = false
			CameraFinish()
			ClearObjectives()
			AddObjective("omegam01.otf", "WHITE")
			audmsg = AudioMessage("avapce0.wav")
        	Goto(BuildObject("aspilo",1,"pilot_spawn"),"pilot_goto",1)
		end
	end
    
    if not goala then
        SetPilot(1,0)
    end
    
	if GetDistance(player,outpost)<120.0 and GetDistance(madison,outpost)<120.0 and not goala then
	    goala = true
        ClearObjectives()
	    AddObjective("omegm01B.otf", "GREEN")
        AddObjective("omegm01C.otf", "WHITE")
        AddObjective("omegm01D.otf", "WHITE")
        Goto(tank,player,0)
        SetObjectiveOn(ccafact)
        SetObjectiveOn(ccarecy)
        SetObjectiveOff(nav)
	end
	
	if not IsValid(madison) and not goalc then
	    goalc = true
	    ClearObjectives()
	    if goala then
	        AddObjective("omegm01B.otf", "GREEN")
	        else
	        AddObjective("omegm01B.otf", "WHITE")
	    end
        AddObjective("omegm01C.otf", "WHITE")
        AddObjective("omegm01D.otf", "RED")   
        mission_lost = true
        audmsg=AudioMessage("spacer8.wav")
    end
    
    if not IsValid(ccafact) and not IsValid(ccarecy) and IsValid(madison) and not goalb then
        goalb = true
        camera4 = true
        ClearObjectives()
	    AddObjective("omegm01B.otf", "GREEN")
        AddObjective("omegm01C.otf", "GREEN")
        AddObjective("omegm01D.otf", "GREEN")
        mission_won = true
        audmsg=AudioMessage("spacer8.wav")
        CameraReady()
    end
    
    if camera4 then
		if CameraPath("camera4",1500,600,GetNearestVehicle("turr4")) or CameraCancelled() then
			camera3 = false
			CameraFinish()
		end
	end
    if mission_won and IsAudioMessageDone(audmsg) then
            SucceedMission(GetTime(),"omegm01w.des")
    end
    
    if mission_lost and IsAudioMessageDone(audmsg) then
            FailMission(GetTime(),"omegm01f.des")
    end
end


