require "math"

local mission_won=false
local mission_lost=false
local goala=false
local goalb=false
local goalc=false
local goald=false
local goale=false
local goalf=false
local goalg=false
local goalh=false
local startup_done=false
local camera1=false
local camera2=false
local camera3=false
local reinforce1=false
local reinforce2=false
local reinforce3=false
local timingdown=false
local loading_done=true


--Resupply Enemy Production Vars
local resupply_period=600.0
local resupply_timer=0.0

local launchpad_period=120.0
local launchpad_timer=0.0

local audmsg=0

local reinforcement_options = {}

local player=nil
local washington=nil
local crarecy=nil
local crafact=nil
local craarmo=nil
local hosp1=nil
local hosp2=nil
local hosp3=nil
local hosp4=nil
local hosp5=nil
local hosp6=nil
local hosp7=nil
local hosp8=nil
local lpad=nil
local buildhere=nil
local reinforcement=nil
local evacuee=nil
local attacker=nil
local camera1star=nil


function Save()
	return 
		-- bools
		mission_won,mission_lost,goala,goalb,goalc,goald,goale,goalf,goalg,goalh,startup_done,camera1,camera2,camera3,reinforce1,reinforce2,reinforce3,timingdown,
		-- floats
		resupply_period,resupply_timer,launchpad_timer,launchpad_period,--[[reinforcement_options,]]
		-- handles
        player,washington,crarecy,crafact,craarmo,hosp1,hosp2,hosp3,hosp4,hosp5,hosp6,hosp7,hosp8,lpad,buildhere,reinforcement,evacuee,attacker,camera1star,
		-- ints
		audmsg
    end

function Load(...)
	if select('#', ...) > 0 then
		-- bools
		mission_won,mission_lost,goala,goalb,goalc,goald,goale,goalf,goalg,goalh,startup_done,camera1,camera2,camera3,reinforce1,reinforce2,reinforce3,timingdown,
		-- floats
		resupply_period,resupply_timer,launchpad_timer,launchpad_period,--[[reinforcement_options,]]
		-- handles
        player,washington,crarecy,crafact,craarmo,hosp1,hosp2,hosp3,hosp4,hosp5,hosp6,hosp7,hosp8,lpad,buildhere,reinforcement,evacuee,attacker,camera1star,
		-- ints
		audmsg
		= ...
		loading_done = false
	end
end

function PostLoad()
end

function AddObject(h)
    if GetTeamNum(h) == 1 and IsOdf(h, "ablpadre") and not IsAlive(lpad) then
        lpad=h
    end
    
    if GetTeamNum(h) == 1 and IsOdf(h, "avcnstlp") then
        RemoveObject(buildhere)
    end
    
end

function reinforce()
    reinforcement=BuildObject(reinforcement_options[math.random(# reinforcement_options)], 1, lpad)
end

function Update ()
    washington = GetHandle("avrecylp0_recycler")
    crarecy = GetHandle("cvremp140_recycler")
    crafact = GetHandle("cvmump140_factory")
    hosp1 = GetHandle("abhqcp25_i76building")
    hosp2 = GetHandle("abmbld0_supplydepot")
    hosp3 = GetHandle("abcafe0_i76building")
    hosp4 = GetHandle("abbarr2_barracks")
    hosp5 = GetHandle("abcafe2_i76building")
    hosp6 = GetHandle("abbarr3_barracks")
    hosp7 = GetHandle("abbarr1_barracks")
    hosp8 = GetHandle("abbarr0_barracks")
    buildhere = GetHandle("ablpadde0_camerapod")
    
    SetAIP("omegam12.aip", 2)--sets the AIP file for team 3.
    --SetPilot (2, 20) --This gives team 2 20 pilots.
    --SetScrap (2, 50) --This gives team 2 50 scrap.

--------------------------------------------------------
--Startup and Camera
--
    if not startup_done then
        startup_done = true
        reinforcement_options = {"avhraz", "avtank", "avtank", "avtank", "avfigh", "avfigh", "avltnk", "avltnk", "avrckt", "avturr",}
        SetMaxHealth(hosp1, 2400.0)
        SetMaxHealth(hosp2, 2400.0)
        SetMaxHealth(hosp3, 2400.0)
        SetMaxHealth(hosp4, 2400.0)
        SetMaxHealth(hosp5, 2400.0)
        SetMaxHealth(hosp6, 2400.0)
        SetMaxHealth(hosp7, 2400.0)
        SetMaxHealth(hosp8, 2400.0)
        SetCurHealth(hosp1, 2400.0)
        SetCurHealth(hosp2, 2400.0)
        SetCurHealth(hosp3, 2400.0)
        SetCurHealth(hosp4, 2400.0)
        SetCurHealth(hosp5, 2400.0)
        SetCurHealth(hosp6, 2400.0)
        SetCurHealth(hosp7, 2400.0)
        SetCurHealth(hosp8, 2400.0)
    end
    if not loading_done then
        loading_done = true
        reinforcement_options = {"avhraz", "avtank", "avtank", "avtank", "avfigh", "avfigh", "avltnk", "avltnk", "avrckt", "avturr",}
        SetMaxHealth(hosp1, 2400.0)
        SetMaxHealth(hosp2, 2400.0)
        SetMaxHealth(hosp3, 2400.0)
        SetMaxHealth(hosp4, 2400.0)
        SetMaxHealth(hosp5, 2400.0)
        SetMaxHealth(hosp6, 2400.0)
        SetMaxHealth(hosp7, 2400.0)
        SetMaxHealth(hosp8, 2400.0)
        SetCurHealth(hosp1, 2400.0)
        SetCurHealth(hosp2, 2400.0)
        SetCurHealth(hosp3, 2400.0)
        SetCurHealth(hosp4, 2400.0)
        SetCurHealth(hosp5, 2400.0)
        SetCurHealth(hosp6, 2400.0)
        SetCurHealth(hosp7, 2400.0)
        SetCurHealth(hosp8, 2400.0)
    end
--------------------------------------------------------
--Basic Script
--  
    if not goala and GetDistance(washington,hosp1)<200.0 then
        goala=true
        ClearObjectives()
        AddObjective("omegm12B.otf", "GREEN")
        AddObjective("omegm12E.otf", "WHITE")
        SetObjectiveOn(buildhere)
    end
    
    if goala and not goalb and IsAlive(lpad) and GetDistance(lpad,hosp1)<300.0 and not timingdown then
        goalb=true
        ClearObjectives()
        AddObjective("omegm12B.otf", "GREEN")
        AddObjective("omegm12F.otf", "GREEN")
        AddObjective("omegm12C.otf", "WHITE")
        AddObjective("omegm12D.otf", "WHITE")
        timingdown=true
        reinforce1=false
        reinforce2=false
        reinforce3=false
        StartCockpitTimer (120.0, 10, 0.0)
    end
    
    if not IsAlive(lpad) then
        timingdown=false
        HideCockpitTimer()
        goalb=false
    end
    
    if goala and goalb and IsAlive(lpad) and timingdown and GetCockpitTimer()==12.0 and not reinforce1 then
        reinforce()
        Goto(reinforcement,"reinforcement_goto",0)
        reinforce1=true
    end
    
    if goala and goalb and IsAlive(lpad) and timingdown and GetCockpitTimer()==10.0 and not reinforce2 then
        reinforce()
        Goto(reinforcement,"reinforcement_goto",0)
        reinforce2=true
    end
    
    if goala and goalb and IsAlive(lpad) and timingdown and GetCockpitTimer()==8.0 and not reinforce3 then
        reinforce()
        Goto(reinforcement,"reinforcement_goto",0)
        reinforce3=true
    end
    
    if goala and goalb and IsAlive(lpad) and timingdown and GetCockpitTimer()==0.0 then
        reinforce1=false
        reinforce2=false
        reinforce3=false
        StartCockpitTimer (120.0, 10, 0.0)
    end
    
    if GetDistance(hosp2,GetNearestEnemy(hosp2))<100.0 and attacker~=GetNearestEnemy(hosp2) then
        attacker=GetNearestEnemy(hosp2)
        Attack(attacker,hosp2,1)
    end
    
    
    if not IsAlive(hosp1) or not IsAlive(hosp2) or not IsAlive(hosp3) or not IsAlive(hosp4) or not IsAlive(hosp5) or not IsAlive(hosp6) or not IsAlive(hosp7) or not IsAlive(hosp8) then
        if not goalf then
        goalf=true
        SetCurHealth(hosp1, 0.0)
        SetCurHealth(hosp2, 0.0)
        SetCurHealth(hosp3, 0.0)
        SetCurHealth(hosp4, 0.0)
        SetCurHealth(hosp5, 0.0)
        SetCurHealth(hosp6, 0.0)
        SetCurHealth(hosp7, 0.0)
        SetCurHealth(hosp8, 0.0)
        ClearObjectives()
        if goala then
            AddObjective("omegm12B.otf", "GREEN")
            else
            AddObjective("omegm12B.otf", "WHITE")
        end
        if goalb then
            AddObjective("omegm12F.otf", "GREEN")
            else
            AddObjective("omegm12F.otf", "WHITE")
        end
        if goalg then
            AddObjective("omegm12C.otf", "GREEN")
            else
            AddObjective("omegm12C.otf", "WHITE")
        end
        HideCockpitTimer()
        AddObjective("omegm12D.otf", "RED")
        mission_lost=true
        audmsg = AudioMessage("spacer8.wav")
        end
    end
    
    if not IsAlive(crarecy) and not IsAlive(crafact) and not goalg then
        goalg=true
        ClearObjectives()
        AddObjective("omegm12B.otf", "GREEN")
        AddObjective("omegm12F.otf", "GREEN")
        AddObjective("omegm12C.otf", "GREEN")
        AddObjective("omegm12D.otf", "GREEN")
        mission_won=true
        audmsg = AudioMessage("spacer8.wav")
    end
        
    
    
--------------------------------------------------------
--Spawning
--

--------------------------------------------------------	
-- AI Resupply Timer
-- This gives the AI more pilots and scrap periodically.
	if resupply_timer<resupply_period then
        resupply_timer = resupply_timer + 0.0167
        else
        resupply_timer = 0.0
        AddPilot (2, 60) 
        AddScrap (2, 140)
    end
    
---------------------------------------------------------
--Mission Completion
--
    if mission_won and IsAudioMessageDone(audmsg) then
            SucceedMission(0.0,"omegm12w.des")
    end
    
    if mission_lost and IsAudioMessageDone(audmsg) then
            FailMission(0.0,"omegm12f.des")
    end
end


