local mission_won=false
local mission_lost=false
local goala=false
local goalb=false
local goalc=false
local goald=false
local goale=false
local goalf=false
local goalg=false
local goalh=false
local startup_done=false
local camera1=false
local camera2=false
local camera3=false



--Resupply Enemy Production Vars
local resupply_period=600.0
local resupply_timer=0.0
local audmsg=0

local player=nil
local crarecy=nil
local crafact=nil
local craarmo=nil
local attacker=nil
local camera1star=nil
local camera2star=nil
local camera3star=nil
local command1=nil
local command2=nil
local satellite=nil


function Save()
	return 
		-- bools
		mission_won,mission_lost,goala,goalb,goalc,goald,goale,goalf,goalg,goalh,startup_done,camera1,camera2,camera3,
		-- floats
		resupply_period,resupply_timer,
		-- handles
        player,crarecy,crafact,craarmo,attacker,camera1star,camera2star,camera3star,command1,command2,satellite,
		-- ints
		audmsg
    end

function Load(...)
	if select('#', ...) > 0 then
		-- bools
		mission_won,mission_lost,goala,goalb,goalc,goald,goale,goalf,goalg,goalh,startup_done,camera1,camera2,camera3,
		-- floats
		resupply_period,resupply_timer,
		-- handles
        player,crarecy,crafact,craarmo,attacker,camera1star,camera2star,camera3star,command1,command2,satellite,
		-- ints
		audmsg
		= ...
	end
end

function PostLoad()
end



function Update ()

    --sets the AIP file for team 3.
    --SetPilot (2, 20) --This gives team 2 20 pilots.
    --SetScrap (2, 50) --This gives team 2 50 scrap.
    player=GetPlayerHandle()
    command1=GetHandle("sbcomm10_commtower")
    command2=GetHandle("sbhqcp10_i76building")
    satellite=GetHandle("bbcommd286_commtower")
--------------------------------------------------------
--Startup and Camera
--
    if not startup_done then
        startup_done = true
        camera1=true
        camera1star = GetHandle("svrecg0_tug")
        camera2star = GetHandle("aptether10_wpnpower")
        camera3star = GetHandle("bvrecyo574_recycler")
        SetObjectiveOff(command1)
        SetObjectiveOff(command2)
        CameraReady()
    end
    
    if camera1 then
		if CameraPath("camera1",1200,350,camera1star) or CameraCancelled() then
			camera1 = false
			camera2 = true
		end
	end
	
	if camera2 then
	    if CameraPath("camera2",50,150,camera2star) or CameraCancelled() then
			camera2 = false
			camera3 = true
		end
    end
    
    if camera3 then
	    if CameraPath("camera3",1200,250,camera3star) or CameraCancelled() then
			camera3 = false
			CameraFinish()
			StartCockpitTimer(720,240,60)
		end
    end
--------------------------------------------------------	
-- AI Resupply Timer
-- This gives the AI more pilots and scrap periodically.
	if resupply_timer<resupply_period then
        resupply_timer = resupply_timer + 0.0167
        else
        resupply_timer = 0.0
        AddPilot (2, 60) 
        AddScrap (2, 200)
    end
    
---------------------------------------------------------
--Mission Components
--   

    if not goale and not goala and not IsAlive(camera2star) and GetDistance(player,"tether")>7.0 then
        goale=true
        ClearObjectives()
        AddObjective("omegm14B.otf","RED")
        AddObjective("omegm14C.otf","WHITE")
        AddObjective("omegm14D.otf","WHITE")
        AddObjective("omegm14E.otf","WHITE")
        mission_lost=true
        audmsg = AudioMessage("spacer8.wav")
    end
    if not goala and not goale and not IsAlive(camera2star) and GetDistance(player,"tether")<=7.0 then
        goala = true
        ClearObjectives()
        if goala then
            AddObjective("omegm14B.otf","GREEN")
            else
            AddObjective("omegm14B.otf","WHITE")
        end
        if goalb then
            AddObjective("omegm14C.otf","GREEN")
            else
            AddObjective("omegm14C.otf","WHITE")
        end
        if goalc then
            AddObjective("omegm14D.otf","GREEN")
            else
            AddObjective("omegm14D.otf","WHITE")
        end
        if goald then
            AddObjective("omegm14E.otf","GREEN")
            else
            AddObjective("omegm14E.otf","WHITE")
        end
    end
    if goala and not goalb and GetTeamNum(camera1star)==1 then
        goalb=true
        SetObjectiveOff(camera1star)
        SetObjectiveOn(satellite)
        ClearObjectives()
        if goala then
            AddObjective("omegm14B.otf","GREEN")
            else
            AddObjective("omegm14B.otf","WHITE")
        end
        if goalb then
            AddObjective("omegm14C.otf","GREEN")
            else
            AddObjective("omegm14C.otf","WHITE")
        end
        if goalc then
            AddObjective("omegm14D.otf","GREEN")
            else
            AddObjective("omegm14D.otf","WHITE")
        end
        if goald then
            AddObjective("omegm14E.otf","GREEN")
            else
            AddObjective("omegm14E.otf","WHITE")
        end
    end
    if goala and goalb and not goalc and GetDistance(camera1star,"uplink")<20.0 then
        goalc=true
        audmsg = AudioMessage("spacer8.wav")
    end
    if goalc and not goalf and IsAudioMessageDone(audmsg) then
        goalf=true
        audmsg = AudioMessage("misns817.wav")
        SetObjectiveOff(satellite)
        SetObjectiveOn(command1)
        SetObjectiveOn(command2)
        SetTeamNum(camera1star,0)
        SetPerceivedTeam(camera1star,1)
        Goto(camera1star,"storage",1)
        ClearObjectives()
        if goala then
            AddObjective("omegm14B.otf","GREEN")
            else
            AddObjective("omegm14B.otf","WHITE")
        end
        if goalb then
            AddObjective("omegm14C.otf","GREEN")
            else
            AddObjective("omegm14C.otf","WHITE")
        end
        if goalc then
            AddObjective("omegm14D.otf","GREEN")
            else
            AddObjective("omegm14D.otf","WHITE")
        end
        if goald then
            AddObjective("omegm14E.otf","GREEN")
            else
            AddObjective("omegm14E.otf","WHITE")
        end
    end
    if not IsAlive(command1) and not IsAlive(command2) and not goald and goala and goalb and goalc then
        goald=true
        audmsg = AudioMessage("spacer8.wav")
        ClearObjectives()
        if goala then
            AddObjective("omegm14B.otf","GREEN")
            else
            AddObjective("omegm14B.otf","WHITE")
        end
        if goalb then
            AddObjective("omegm14C.otf","GREEN")
            else
            AddObjective("omegm14C.otf","WHITE")
        end
        if goalc then
            AddObjective("omegm14D.otf","GREEN")
            else
            AddObjective("omegm14D.otf","WHITE")
        end
        if goald then
            AddObjective("omegm14E.otf","GREEN")
            else
            AddObjective("omegm14E.otf","WHITE")
        end
        mission_won=true
        audmsg=AudioMessage("spacer8.wav")
    end
    
    if not goalg and not IsAlive(camera1star) then
        goalg=true
        ClearObjectives()
        AddObjective("omegam14.otf","RED")
        mission_lost=true
        audmsg=AudioMessage("spacer5.wav")
    end
    
    if not goalh and not goald and startup_done and not camera1 and not camera2 and not camera3 and GetCockpitTimer()==0.0 then
        goalh=true
        ClearObjectives()
        AddObjective("omegam14.otf","RED")
        mission_lost=true
        audmsg=AudioMessage("spacer5.wav")
    end
    
    
---------------------------------------------------------
--Mission Completion
--
    if mission_won and IsAudioMessageDone(audmsg) then
            SucceedMission(GetTime(),"omegm14w.des")
    end
    
    if mission_lost and IsAudioMessageDone(audmsg) then
            FailMission(GetTime(),"omegm14f.des")
    end
end


