local mission_won=false
local mission_lost=false
local goala=false
local goalb=false
local goalc=false
local goald=false
local goale=false
local stage1=false
local stage2=false
local stage3=false
local periodicspawn=false
local furyspawn01=false
local furyspawn02=false
local furyspawn03=false
local furyspawn04=false
local furyspawn05=false
local furyspawn06=false
local furyspawn07=false
local furyspawn08=false
local furyspawn09=false
local furyspawn10=false
local furyspawn11=false
local startup_done=false
local loading_done=true

--Resupply Enemy Production Vars
local resupply1_period=60.0
local resupply1_timer=0.0
local resupply2_period=60.0
local resupply2_timer=0.0
local resupply3_period=45.0
local resupply3_timer=0.0
local scrappool_period=90.0
local scrappool_timer=0.0

local commtow_health=5500.0
local hq_health=4750.0

local player=nil
local attacker=nil
local myrecy=nil
local commtow=nil
local headquarters=nil
local rogue1=nil
local rogue2=nil

local audmsg=0


function Save()
	return 
		-- bools
		mission_won,mission_lost,goala,goalb,goalc,goald,goale,stage1,stage2,stage3,periodicspawn,furyspawn01,furyspawn02,furyspawn03,furyspawn04,furyspawn05,furyspawn06,
        furyspawn07,furyspawn08,furyspawn09,furyspawn10,furyspawn11,startup_done,
		-- floats
		resupply1_period,resupply1_timer,resupply2_period,resupply2_timer,resupply3_period,resupply3_timer,scrappool_period,scrappool_timer,commtow_health,hq_health,
		-- handles
        player,attacker,myrecy,commtow,headquarters,rogue1,rogue2,
		-- ints
		audmsg
    end

function Load(...)
	if select('#', ...) > 0 then
		-- bools
		mission_won,mission_lost,goala,goalb,goalc,goald,goale,stage1,stage2,stage3,periodicspawn,furyspawn01,furyspawn02,furyspawn03,furyspawn04,furyspawn05,furyspawn06,
        furyspawn07,furyspawn08,furyspawn09,furyspawn10,furyspawn11,startup_done,
		-- floats
		resupply1_period,resupply1_timer,resupply2_period,resupply2_timer,resupply3_period,resupply3_timer,scrappool_period,scrappool_timer,commtow_health,hq_health,
		-- handles
        player,attacker,myrecy,commtow,headquarters,rogue1,rogue2,
		-- ints
		audmsg
		= ...
		loading_done=false
	end
end

function PostLoad()
end

function AddObject(h)
    if IsOdf(h,"svsavo1") and GetTeamNum(h) == 2 and not IsAlive(rogue1) then
        rogue1=h
    end
    if IsOdf(h,"svsavo1") and GetTeamNum(h) == 2 and not IsAlive(rogue2) then
        rogue2=h
    end
end

SetAIControl(2,true)
SetAIControl(3,true)

function Update ()

    SetAIP("omegam16.aip", 2)--sets the AIP file for team 3.
    --SetPilot (2, 20) --This gives team 2 20 pilots.
    --SetScrap (2, 50) --This gives team 2 50 scrap.
    player=GetPlayerHandle()
    myrecy=GetHandle("bvrecyo710_recycler")
    commtow=GetHandle("abcomm7_commtower")
    headquarters=GetHandle("abmbld9_supplydepot")
    commtow_health=GetCurHealth(commtow)
    hq_health=GetCurHealth(headquarters)
    
--------------------------------------------------------
--Startup and Camera
--
    if not startup_done then
        startup_done = true
        StartCockpitTimer(1200.0,780.0,180.0)
        SetMaxHealth(commtow,5500.0)
        SetCurHealth(commtow,5500.0)
        SetMaxHealth(headquarters,4750.0)
        SetCurHealth(headquarters,4750.0)
        UnAlly(2,3)
    end
    
    if not loading_done then
        loading_done=true
        stage1=true
        SetMaxHealth(commtow,5500.0)
        SetCurHealth(commtow,commtow_health)
        SetMaxHealth(headquarters,4750.0)
        SetCurHealth(headquarters,hq_health)
        UnAlly(2,3)
        rogue1=nil
        rogue2=nil
    end
    

--------------------------------------------------------	
-- AI Resupply Timers
-- This gives the AI more pilots and scrap periodically.
	if GetCockpitTimer()<=780.0 and not stage2 then
        stage2=true
    end
    if GetCockpitTimer()<=180.0 and not stage3 then
        stage3=true
    end

    if resupply1_timer<resupply1_period and stage1 then
        resupply1_timer = resupply1_timer + 0.0167
        else
        resupply1_timer = 0.0
        AddPilot (2, 60) 
        AddScrap (2, 10)
    end
    if resupply2_timer<resupply2_period and stage2 then
        resupply2_timer = resupply2_timer + 0.0167
        else
        resupply2_timer = 0.0
        AddPilot (2, 60) 
        AddScrap (2, 24)
    end
    if resupply3_timer<resupply3_period and stage3 then
        resupply3_timer = resupply3_timer + 0.0167
        else
        resupply3_timer = 0.0
        AddPilot (2, 60) 
        AddScrap (2, 30)
    end
    if scrappool_timer<scrappool_period then
        scrappool_timer = scrappool_timer+ 0.0167
        else
        scrappool_timer = 0.0
        BuildObject("sfield",2,"scrappool")
    end
    
    
---------------------------------------------------------
--Mission Components
--
--[[
    if GetDistance(rogue1,"home_base")<300.0 and GetTeamNum(rogue1) == 2 then
        SetTeamNum(rogue1,3)
    end
    if GetDistance(rogue2,"home_base")<300.0 and GetTeamNum(rogue2) == 2 then
        SetTeamNum(rogue2,3)
    end]]
    if GetCockpitTimer()<1100.0 and not furyspawn01 then
        furyspawn01=true
        attacker=BuildObject("svsavo1",2,"sav_spawn1")
        attacker=BuildObject("svsavo1",2,"sav_spawn2")
        --attacker=BuildObject("svsavo1",2,"sav_spawn3")
    end
    
    if GetCockpitTimer()<930.0 and not furyspawn02 then
        furyspawn02=true
        attacker=BuildObject("svsavo1",2,"sav_spawn1")
       -- attacker=BuildObject("svsavo1",2,"sav_spawn2")
      --  attacker=BuildObject("svsavo1",2,"sav_spawn3")
    end
    
    if GetCockpitTimer()<810.0 and not furyspawn03 then
        furyspawn03=true
        attacker=BuildObject("svsavo1",2,"sav_spawn1")
        attacker=BuildObject("svsavo1",2,"sav_spawn2")
        attacker=BuildObject("svsavo1",2,"sav_spawn2")
     --   attacker=BuildObject("svsavo1",2,"sav_spawn3")
    end
    
    if GetCockpitTimer()<750.0 and not furyspawn04 then
        furyspawn04=true
        attacker=BuildObject("svsavo1",2,"sav_spawn1")
        attacker=BuildObject("svsavo1",2,"sav_spawn1")
    --  attacker=BuildObject("svsavo1",2,"sav_spawn2")
      --attacker=BuildObject("svsavo1",2,"sav_spawn3")
    end
    
--

    if GetCockpitTimer()<570.0 and not furyspawn05 then
        furyspawn05=true
        attacker=BuildObject("svsavo1",2,"sav_spawn3")
        attacker=BuildObject("svsavo1",2,"sav_spawn3")
      -- attacker=BuildObject("svsavo1",2,"sav_spawn3")
      --  attacker=BuildObject("svsavo1",2,"sav_spawn1")
    end
    
    if GetCockpitTimer()<450.0 and not furyspawn06 then
        furyspawn06=true
        attacker=BuildObject("svsavo1",2,"sav_spawn1")
        attacker=BuildObject("svsavo1",2,"sav_spawn2")
      --  attacker=BuildObject("svsavo1",2,"sav_spawn3")
      --  attacker=BuildObject("svsavo1",2,"sav_spawn2")
    end
    
    if GetCockpitTimer()<330.0 and not furyspawn07 then
        furyspawn07=true
        attacker=BuildObject("svsavo1",2,"sav_spawn1")
        attacker=BuildObject("svsavo1",2,"sav_spawn1")
        attacker=BuildObject("svsavo1",2,"sav_spawn1")
      --  attacker=BuildObject("svsavo1",2,"sav_spawn1")
    end
    
    if GetCockpitTimer()<210.0 and not furyspawn08 then
        furyspawn08=true
        attacker=BuildObject("svsavo1",2,"sav_spawn1")
        attacker=BuildObject("svsavo1",2,"sav_spawn2")
     --  attacker=BuildObject("svsavo1",2,"sav_spawn3")
     --   attacker=BuildObject("svsavo1",2,"sav_spawn2")
        Attack(attacker,commtow,1)
    end
    
--
 
    if GetCockpitTimer()<150.0 and not furyspawn09 then
        furyspawn09=true
        attacker=BuildObject("svsavo1",2,"sav_spawn1")
      --  attacker=BuildObject("svsavo1",2,"sav_spawn2")
      --  attacker=BuildObject("svsavo1",2,"sav_spawn3")
      --  attacker=BuildObject("svsavo1",2,"sav_spawn2")
      --  attacker=BuildObject("svsavo1",2,"sav_spawn3")
        Attack(attacker,myrecy,1)
    end
    
    if GetCockpitTimer()<90.0 and not furyspawn10 then
        furyspawn10=true
        attacker=BuildObject("svsavo1",2,"sav_spawn1")
        attacker=BuildObject("svsavo1",2,"sav_spawn2")
      --  attacker=BuildObject("svsavo1",2,"sav_spawn2")
      --  attacker=BuildObject("svsavo1",2,"sav_spawn2")
      -- attacker=BuildObject("svsavo1",2,"sav_spawn3")
        Attack(attacker,headquarters,1)
    end
    
    if GetCockpitTimer()<60.0 and not furyspawn11 then
        furyspawn11=true
        attacker=BuildObject("svsavo1",2,"sav_spawn1")
        attacker=BuildObject("svsavo1",2,"sav_spawn2")
        attacker=BuildObject("svsavo1",2,"sav_spawn3")
       -- attacker=BuildObject("svsavo1",2,"sav_spawn2")
       -- attacker=BuildObject("svsavo1",2,"sav_spawn1")
        Attack(attacker,myrecy,1)
    end
    
---------------------------------------------------------    
    
---------------------------------------------------------
--Mission Completion
--
    if GetCockpitTimer()==0.0 and not goala and not goalb then
        goala=true
        ClearObjectives()
        AddObjective("omegam16.otf","GREEN")
        audmsg=AudioMessage("spacer5.wav")
        mission_won=true
    end
    if not goalb then
        if not IsAlive(myrecy) or not IsAlive(commtow) or not IsAlive(headquarters) then
            goalb=true
            ClearObjectives()
            AddObjective("omegam16.otf","RED")
            audmsg=AudioMessage("spacer5.wav")
            mission_lost=true
        end
    end
    
    if mission_won and IsAudioMessageDone(audmsg) then
            SucceedMission(GetTime(),"omegm16w.des")
    end
    
    if mission_lost and IsAudioMessageDone(audmsg) then
            FailMission(GetTime(),"omegm16f.des")
    end
end


