local mission_won=false
local mission_lost=false
local goala=false
local goalb=false
local goalc=false
local goald=false
local goale=false
--Resupply Enemy Production Vars
local resupply_period=900.0
local resupply_timer=0.0
local audmsg=0

local newrec=nil
local fwdfact=nil
local ccarecy=nil
local ccafact=nil
local player=nil
local geyser=nil
local attackera=nil
local attackerb=nil
local turret1=nil
local turret2=nil
local turret3=nil
local turret4=nil
local turret5=nil
local turret6=nil
local turret7=nil
local defender1=nil
local defender2=nil
local defender3=nil
local defender4=nil
local defender5=nil

function Save()
	return 
		-- bools
		mission_won,mission_lost,goala,goalb,goalc,goald,goale,
		-- floats
		resupply_period,resupply_timer,
		-- handles
        newrec,fwdfact,ccarecy,ccafact,player,geyser,attackera,attackerb,turret1,turret2,turret3,turret4,turret5,
        turret6,turret7,defender1,defender2,defender3,defender4,defender5,
		-- ints
		audmsg
    end

function Load(...)
	if select('#', ...) > 0 then
		-- bools
		mission_won,mission_lost,goala,goalb,goalc,goald,goale,
		-- floats
		resupply_period,resupply_timer,
		-- handles
        newrec,fwdfact,ccarecy,ccafact,player,geyser,attackera,attackerb,turret1,turret2,turret3,turret4,turret5,
        turret6,turret7,defender1,defender2,defender3,defender4,defender5,
		-- ints
		audmsg
		= ...
	end
end

function PostLoad()
end



function Update ()

    SetAIP("omegam03.aip", 2) --sets the AIP file for team 3.
    --SetPilot (2, 20) --This gives team 3 20 pilots.
    --SetScrap (2, 50) --This gives team 3 50 scrap.


    
	player = GetPlayerHandle()
    ccarecy = GetHandle("svrecy1_recycler")
    geyser = GetHandle("eggeizr10_geyser")
    turret1 = GetHandle("avturr31_turrettank")
    turret2 = GetHandle("avturr32_turrettank")
    turret3 = GetHandle("avturr33_turrettank")
    turret4 = GetHandle("avturr34_turrettank")
    turret5 = GetHandle("avturr35_turrettank")
    turret6 = GetHandle("avturr36_turrettank")
    turret7 = GetHandle("avturr37_turrettank")
    defender1 = GetHandle("avtank43_wingman")
    defender2 = GetHandle("avtank42_wingman")
    defender3 = GetHandle("avfigh42_wingman")
    defender4 = GetHandle("avfigh43_wingman")
    defender5 = GetHandle("avltnk42_wingman")

-- AI Resupply Timer
-- This gives the AI more pilots and scrap periodically.
	if resupply_timer<resupply_period then
        resupply_timer = resupply_timer + 0.0167
        else
        resupply_timer = 0.0
        AddPilot (2, 60) 
        AddScrap (2, 100)
    end	
	
	if not goald then
	    fwdfact = GetNearestVehicle("fwdfact")
	    goald = true
	    end
	
	if not IsValid(fwdfact) and not goala then
	    goala = true
	    ClearObjectives()
	    AddObjective("omegm03B.otf", "GREEN")
	    AddObjective("omegm03C.otf", "WHITE")
	    AddObjective("omegm03D.otf", "WHITE")
	    newrec = BuildObject("avrec9",1,"recspawn")
	    Goto(newrec,"recypath",1)
	    SetObjectiveOn(newrec)
	    SetObjectiveOn(geyser)
	    attackera = BuildObject("svfigh",2,"attackera")
	    Attack(attackera,newrec,1)
	    attackerb = BuildObject("svtank",2,"attackerb")
	    Attack(attackerb,newrec,1)
	    Stop(turret1,0)
	    Stop(turret2,0)
	    Stop(turret3,0)
	    Goto(turret4,"turret4go",0)
	    Goto(turret5,"turret5go",0)
	    Goto(turret6,"turret6go",0)
	    Goto(turret7,"turret7go",0)
	    else
	    SetObjectiveOn(fwdfact)	    
	    
	end
	
	if GetDistance(newrec,geyser)<70.0 and goala and not goalb then
	    goalb = true
	   	ClearObjectives()
	    AddObjective("omegm03B.otf", "GREEN")
	    AddObjective("omegm03C.otf", "GREEN")
	    AddObjective("omegm03D.otf", "WHITE")
	    SetObjectiveOff(newrec)
	    SetObjectiveOff(geyser)
	    SetObjectiveOn(ccarecy)
	    ccafact = GetHandle("svmuf0_factory")
	    SetObjectiveOn(ccafact)
	    Stop(defender1,0)
	    Stop(defender2,0)
	    Stop(defender3,0)
	    Stop(defender4,0)
	    Stop(defender5,0)
	end
	
	if goala and not goalb and not goale and not IsValid(newrec) then
	    goale=true
	    ClearObjectives()
	    AddObjective("omegm03B.otf", "GREEN")
	    AddObjective("omegm03C.otf", "RED")
	    AddObjective("omegm03D.otf", "WHITE")
        audmsg=AudioMessage("spacer8.wav")
		mission_lost=true    
	end
	
	if not IsValid(ccarecy) and not IsValid(ccafact) and goala and not goalc then
	    goalc = true
	    ClearObjectives()
	    AddObjective("omegm03B.otf", "GREEN")
	    AddObjective("omegm03C.otf", "GREEN")
	    AddObjective("omegm03D.otf", "GREEN")
	    audmsg=AudioMessage("spacer8.wav")
		mission_won=true 
    end 
	    
    
    if mission_won and IsAudioMessageDone(audmsg) then
            SucceedMission(GetTime(),"omegm03w.des")
    end
    
    if mission_lost and IsAudioMessageDone(audmsg) then
            FailMission(GetTime(),"omegm03f.des")
    end
end


