local mission_won=false
local mission_lost=false
local goala=false
local goalb=false
local goalc=false
local goald=false
local hastarget=false
local startup_done=false
local camera1=false
local ismining1=false
local ismining2=false
local ismining3=false
local loading_done = true

--Resupply Enemy Production Vars
local resupply_period=450.0
local resupply_timer=0.0
local audmsg=0

local player=nil
local sniper1=nil
local sniper2=nil
local soldier1=nil
local soldier2=nil
local soldier3=nil
local soldier4=nil
local fakeapc=nil
local fakebarr=nil
local dummy=nil
local attacker=nil
local figh1=nil
local tank5=nil
local tank6=nil
local miner1=nil
local miner2=nil
local miner3=nil

function Save()
	return 
		-- bools
		mission_won,mission_lost,goala,goalb,goalc,goald,hastarget,startup_done,camera1,ismining1,ismining2,ismining3,
		-- floats
		resupply_period,resupply_timer,
		-- handles
        player,sniper1,sniper2,soldier1,soldier2,soldier3,soldier4,fakeapc,fakebarr,dummy,attacker,figh1,tank5,tank6,miner1,miner2,miner3,
		-- ints
		audmsg
    end

function Load(...)
	if select('#', ...) > 0 then
		-- bools
		mission_won,mission_lost,goala,goalb,goalc,goald,hastarget,startup_done,camera1,ismining1,ismining2,ismining3,
		-- floats
		resupply_period,resupply_timer,
		-- handles
        player,sniper1,sniper2,soldier1,soldier2,soldier3,soldier4,fakeapc,fakebarr,dummy,attacker,figh1,tank5,tank6,miner1,miner2,miner3,
		-- ints
		audmsg
		= ...
		loading_done = false
	end
end

function PostLoad()
end



function Update ()

    --SetAIP("omegam06.aip", 2)--sets the AIP file for team 3.
    --SetPilot (2, 20) --This gives team 3 20 pilots.
    --SetScrap (2, 50) --This gives team 3 50 scrap.
    
	player = GetPlayerHandle()
	supp1 = GetHandle("sbsupp0_supplydepot")
	supp2 = GetHandle("sbsupp3_supplydepot")
	supp3 = GetHandle("sbsupp1_supplydepot")
	supp4 = GetHandle("sbsupp2_supplydepot")
	fakeapc = GetHandle("avapcfke0_apc")
	dummy = GetHandle("sscr_10_scrap")
	figh1 = GetHandle("svfigh1_wingman")
	tank6 = GetHandle("svtank6_wingman")
	tank5 = GetHandle("svtank5_wingman")
	miner1 = GetHandle("svmine2_minelayer")
	miner2 = GetHandle("svmine4_minelayer")
	miner3 = GetHandle("svmine5_minelayer")
	
    if not startup_done then
        startup_done = true
        CameraReady()
        camera1 = true
        fakebarr = BuildObject("abbarr",3,"apcreturn")
        SetMaxHealth(supp1,1000.0)
        SetMaxHealth(supp2,1000.0)
        SetMaxHealth(supp3,1000.0)
        SetMaxHealth(supp4,1000.0)
        SetCurHealth(supp1,1000.0)
        SetCurHealth(supp2,1000.0)
        SetCurHealth(supp3,1000.0)
        SetCurHealth(supp4,1000.0) 
    end
    
    if not loading_done then
	    loading_done = true
	    SetMaxHealth(supp1,1000.0)
        SetMaxHealth(supp2,1000.0)
        SetMaxHealth(supp3,1000.0)
        SetMaxHealth(supp4,1000.0)
        SetCurHealth(supp1,1000.0)
        SetCurHealth(supp2,1000.0)
        SetCurHealth(supp3,1000.0)
        SetCurHealth(supp4,1000.0) 
    end
    
    if camera1 then
		if CameraPath("camera1",1200,400,fakeapc) or CameraCancelled() then
			camera1 = false
			camera2 = true
			RemoveObject(fakeapc)
			RemoveObject(fakebarr)
		end
	end

    if camera2 then
		if CameraPathDir ("camera2",300,2400) or CameraCancelled() then
			camera2 = false
			CameraFinish()
			RemoveObject(fakeapc)
			RemoveObject(fakebarr)
			ClearObjectives()
			AddObjective("omegam06.otf","WHITE")
			sniper1 = BuildObject("hssnpr",1,"hssnpr1")
	        sniper2 = BuildObject("hssnpr",1,"hssnpr2")
	        soldier1 = BuildObject("hsmarn",1,"hsmarn1")
	        soldier2 = BuildObject("hsmarn",1,"hsmarn2")
	        soldier3 = BuildObject("hsmarn",1,"hsmarn3")
	        soldier4 = BuildObject("hsmarn",1,"hsmarn4")
	        Follow(soldier1,player,0)
	        Follow(soldier2,player,0)
	        Follow(soldier3,player,0)
	        Follow(soldier4,player,0)
	        Follow(sniper1,player,0)
	        Follow(sniper2,player,0)
	        StartCockpitTimer(1200.0,300.0,0.0)
	        Defend2(figh1,sbsupp4,1)
	        Defend2(tank5,sbsupp3,1)
	        Defend2(tank6,sbsupp4,1)
	        goalc = true
		end
	end
	
	if not camera1 then
	    if IsOdf(GetNearestObject(dummy),"assold") then
	        RemoveObject(GetNearestObject(dummy))
	    end
	end
	--[[
	--Follow stuff
	--
	if GetDistance(player,sniper1)>500.0 then
	    Follow(sniper1,player,0)
	end
	if GetDistance(player,sniper2)>500.0 then
	    Follow(sniper2,player,0)
	end
	if GetDistance(player,soldier1)>500.0 then
	    Follow(soldier1,player,0)
	end
	if GetDistance(player,soldier2)>500.0 then
	    Follow(soldier2,player,0)
	end
	if GetDistance(player,soldier3)>500.0 then
	    Follow(soldier3,player,0)
	end
	if GetDistance(player,soldier4)>500.0 then
	    Follow(soldier4,player,0)
	end
    ---------------]]
    
    if not goala and not IsAlive(supp1) and not IsAlive(supp2) and not IsAlive(supp3) and not IsAlive(supp4) then
        goala = true
        ClearObjectives()
        AddObjective("omegm06B.otf","GREEN")
        AddObjective("omegm06C.otf","GREEN")
        AddObjective("omegm06D.otf","GREEN")
        mission_won = true
        audmsg = AudioMessage("spacer8.wav")
   end
    
    if GetCockpitTimer()==0 and not goalb and goalc then
        goalb = true
        attacker = BuildObject("svtank",2,"neutralize")
        Attack(attacker,player,1)
        attacker = BuildObject("svtank",2,"neutralize")
        Attack(attacker,player,1)
        attacker = BuildObject("svtank",2,"neutralize")
        Attack(attacker,player,1)
        attacker = BuildObject("svtank",2,"neutralize")
        Attack(attacker,player,1)
        attacker = BuildObject("svtank",2,"neutralize")
        Attack(attacker,player,1)
        attacker = BuildObject("svhraz",2,"neutralize")
        Attack(attacker,player,1)
        attacker = BuildObject("svhraz",2,"neutralize")
        Attack(attacker,player,1)
        attacker = BuildObject("svhraz",2,"neutralize")
        Attack(attacker,player,1)
        attacker = BuildObject("svfigh",2,"neutralize")
        Attack(attacker,player,1)
        attacker = BuildObject("svfigh",2,"neutralize")
        Attack(attacker,player,1)
        attacker = BuildObject("svfigh",2,"neutralize")
        Attack(attacker,player,1)
        attacker = BuildObject("svfigh",2,"neutralize")
        Attack(attacker,player,1)
        attacker = BuildObject("svfigh",2,"neutralize")
        Attack(attacker,player,1)
        ClearObjectives()
        AddObjective("omegm06B.otf","WHITE")
        AddObjective("omegm06C.otf","WHITE")
        AddObjective("omegm06D.otf","YELLOW")
    end
    
    if GetAmmo(miner1)<0.1 and ismining1 then
        Goto(miner1,"supply1",1)
        ismining1=false
    elseif GetAmmo(miner1)>0.9 and not ismining1 then
        ismining1=true
        Mine(miner1,"mine1",1)
    end
    if GetAmmo(miner2)<0.1 and ismining2  then
        Goto(miner2,"supply2",1)
        ismining2=false
    elseif GetAmmo(miner2)>0.9 and not ismining2 then
        ismining2=true
        Mine(miner2,"mine2",1)
    end
    if GetAmmo(miner3)<0.1 and ismining3  then
        Goto(miner3,"supply3",1)
        ismining3=false
    elseif GetAmmo(miner3)>0.9 and not ismining3 then
        ismining3=true
        Mine(miner3,"mine3",1)
    end

    
    if GetDistance(player,GetNearestEnemy(player))<=300.0 and not hastarget then
        SetObjectiveOn(GetNearestEnemy(player))
        hastarget=true
    end
    if GetDistance(player,GetNearestEnemy(player))>300.0 and hastarget then
        SetObjectiveOff(GetNearestEnemy(player))
        hastarget=false
    end
    
    
    
    if mission_won and IsAudioMessageDone(audmsg) then
            SucceedMission(GetTime(),"omegm06w.des")
    end
    
    if mission_lost and IsAudioMessageDone(audmsg) then
            FailMission(GetTime(),"omegm06f.des")
    end
end


