local mission_won=false
local mission_lost=false
local goala=false
local goalb=false
local goalc=false
local goald=false
local loading_done=true

--Resupply Enemy Production Vars
local resupply_period=600.0
local resupply_timer=0.0
local scientist_period=60.0
local scientist_timer=0.0
local audmsg=0

local player=nil
local station1=nil
local station2=nil
local station3=nil
local station4=nil
local station5=nil
local station6=nil
local ccarecy=nil
local ccafact=nil
local ccaarmo=nil
local scientist1=nil
local scientist2=nil
local scientist3=nil
local scientist4=nil
local scientist5=nil

function Save()
	return 
		-- bools
		mission_won,mission_lost,goala,goalb,goalc,goald,
		-- floats
		resupply_period,resupply_timer,scientist_period,scientist_timer,
		-- handles
        player,station1,station2,station3,station4,station5,station6,ccarecy,ccafact,ccaarmo,--[[scientist1,scientist2,scientist3,scientist4,scientist5,]]
		-- ints
		audmsg
    end

function Load(...)
	if select('#', ...) > 0 then
		-- bools
		mission_won,mission_lost,goala,goalb,goalc,goald,
		-- floats
		resupply_period,resupply_timer,scientist_period,scientist_timer,
		-- handles
        player,station1,station2,station3,station4,station5,station6,ccarecy,ccafact,ccaarmo,--[[scientist1,scientist2,scientist3,scientist4,scientist5,]]
		-- ints
		audmsg
		= ...
		loading_done=false
	end
end

function PostLoad()
end



function Update ()

    SetAIP("omegam07.aip", 2)--sets the AIP file for team 3.
    --SetPilot (2, 20) --This gives team 3 20 pilots.
    --SetScrap (2, 50) --This gives team 3 50 scrap.

    player = GetPlayerHandle()
    station1 = GetHandle("sbbarr38_barracks")
    station2 = GetHandle("sbhqcp35_i76building")
    station3 = GetHandle("sbbarr29_barracks")
    station4 = GetHandle("sbcomm16_commtower")
    station5 = GetHandle("sbhqcp2_i76building")
    station6 = GetHandle("sbcafe1_i76building")
    ccarecy = GetHandle("svrecy47_recycler")
    ccafact = GetHandle("svmuf46_factory")
    ccaarmo = GetHandle("svslf43_armory")
    
    if not loading_done then
        loading_done=true
    end
    
   	if resupply_timer<resupply_period then
        resupply_timer = resupply_timer + 0.0167
        else
        resupply_timer = 0.0
        AddPilot (2, 60) 
        AddScrap (2, 100)
    end
    
    if scientist_timer<scientist_period then
        scientist_timer = scientist_timer + 0.0167
        else
        scientist_timer = 0.0
    end

    if IsAlive(station1) and not IsAlive(scientist1) and scientist_timer>59.0 then
        scientist1 = BuildObject("sssold",2,"scientistpatrol1")
        SetPathLoop("scientistpatrol1")
        Patrol(scientist1,"scientistpatrol1",1)
    end
    if IsAlive(station3) and not IsAlive(scientist2) and scientist_timer>59.0 then
        scientist2 = BuildObject("sssold",2,"scientistpatrol2")
        SetPathLoop("scientistpatrol2")
        Patrol(scientist2,"scientistpatrol2",1)
    end
    if IsAlive(station3) and not IsAlive(scientist3) and scientist_timer>59.0 then
        scientist3 = BuildObject("sssold",2,"scientistpatrol2")
        SetPathLoop("scientistpatrol2")
        Patrol(scientist3,"scientistpatrol2",1)
    end
    if IsAlive(station2) and not IsAlive(scientist4) and scientist_timer>59.0 then
        scientist4 = BuildObject("sssold",2,"scientistpatrol3")
        SetPathLoop("scientistpatrol3")
        Patrol(scientist4,"scientistpatrol3",1)
    end
    if IsAlive(station6) and not IsAlive(scientist5) and scientist_timer>59.0 then
        scientist5 = BuildObject("sssold",2,"scientistpatrol4")
        SetPathLoop("scientistpatrol4")
        Patrol(scientist5,"scientistpatrol4",1)
    end

----------------------------
-- Main Objectives
    if not IsAlive(station1) and not IsAlive(station2) and not IsAlive(station3) and not IsAlive(station4) and not IsAlive(station5) and not IsAlive(station6) and not goala then
        goala = true
	    ClearObjectives()
	    AddObjective("omegm07B.otf", "GREEN")
	    AddObjective("omegm07C.otf", "WHITE")	
    end
    
    if not IsAlive(ccarecy) and not IsAlive(ccafact) and not IsAlive(ccaarmo) and not goalb then
        goalb = true
	    ClearObjectives()
	    AddObjective("omegm07B.otf", "GREEN")
	    AddObjective("omegm07C.otf", "GREEN")	
    end
    
    if goala and goalb and not goalc then
        goalc = true
        mission_won = true
        audmsg = AudioMessage("spacer8.wav")
    end
    
--Mission Completion
--
    if mission_won and IsAudioMessageDone(audmsg) then
            SucceedMission(GetTime(),"omegm07w.des")
    end
    
    if mission_lost and IsAudioMessageDone(audmsg) then
            FailMission(GetTime(),"omegm07f.des")
    end
end


