local mission_won=false
local mission_lost=false
local goala=false
local goalb=false
local goalc=false
local goald=false
local goale=false
local goalf=false
local goalg=false
local goalh=false
local startup_done=false
local camera1=false
local camera2=false
local camera3=false
local camera4=false
local camera5=false


--Resupply Enemy Production Vars
local resupply_period=600.0
local resupply_timer=0.0
local audmsg=0


local player=nil
local ccarecy=nil
local ccafact=nil
local ccaarmo=nil
local attacker=nil
local sniper1=nil
local sniper2=nil
local sniper3=nil
local sniper4=nil
local sniper5=nil
local sniper6=nil
local sniper7=nil
local scavenger=nil
local scavenger2=nil
local prison1=nil
local prison2=nil
local silo=nil


function Save()
	return 
		-- bools
		mission_won,mission_lost,goala,goalb,goalc,goald,goale,goalf,goalg,goalh,startup_done,camera1,camera2,camera3,
		-- floats
		resupply_period,resupply_timer,
		-- handles
        player,ccarecy,ccafact,ccaarmo,attacker,sniper1,sniper2,sniper3,sniper4,sniper5,sniper6,sniper7,scavenger,scavenger2,prison1,prison2,silo,
		-- ints
		audmsg
    end

function Load(...)
	if select('#', ...) > 0 then
		-- bools
		mission_won,mission_lost,goala,goalb,goalc,goald,goale,goalf,goalg,goalh,startup_done,camera1,camera2,camera3,
		-- floats
		resupply_period,resupply_timer,
		-- handles
        player,ccarecy,ccafact,ccaarmo,attacker,sniper1,sniper2,sniper3,sniper4,sniper5,sniper6,sniper7,scavenger,scavenger2,prison1,prison2,silo,
		-- ints
		audmsg
		= ...
	end
end

function PostLoad()
end

function Objectives()
    ClearObjectives()
    if goala then
    AddObjective("omegm08B.otf", "GREEN")
    else
    AddObjective("omegm08B.otf", "WHITE")
    end
    
    if goalb then
    AddObjective("omegm08C.otf", "GREEN")
    else
    AddObjective("omegm08C.otf", "WHITE")
    end
    
    if goalc then
    AddObjective("omegm08D.otf", "GREEN")
    else
    AddObjective("omegm08D.otf", "WHITE")
    end
    
    if goald and goale then
    AddObjective("omegm08E.otf", "GREEN")
    else
    AddObjective("omegm08E.otf", "WHITE")
    end
    
    if goalf then
    AddObjective("omegm08F.otf", "GREEN")
    else
    AddObjective("omegm08F.otf", "WHITE")
    end
end
     


function Update ()

    SetAIP("omegam08.aip", 2)
    --SetPilot (2, 20) --This gives team 3 20 pilots.
    --SetScrap (2, 50) --This gives team 3 50 scrap.

--------------------------------------------------------
--Startup and Camera
--
    player = GetPlayerHandle()
    sniper1 = GetHandle("sssnipr1_person")
    sniper2 = GetHandle("sssnipr2_person")
    sniper3 = GetHandle("sssnipr3_person")
    sniper4 = GetHandle("sssnipr4_person")
    sniper5 = GetHandle("sssnipr5_person")
    sniper6 = GetHandle("sssnipr6_person")
    sniper7 = GetHandle("sssnipr7_person")
    scavenger = GetHandle("svscav1_scavenger")
    scavenger2 = GetHandle("svscav0_scavenger")
    prison1 = GetHandle("sbjail1_i76building")
    prison2 = GetHandle("sbjail0_i76building")
    ccarecy = GetHandle("svrecy6_recycler")
    silo = GetHandle("sbsilo0_scrapsilo")    
    
    if not startup_done then
        startup_done = true
        camera1=true
        CameraReady()
    end
    
    if camera1 then
		if CameraPath("camera1",7000,250,sniper1) or CameraCancelled() then
			camera1 = false
			camera2 = true
		end
	end
	
	if camera2 then
		if CameraPath("camera2",1200,250,sniper3) or CameraCancelled() then
			camera2 = false
			camera3 = true
		end
	end
	
	if camera3 then
		if CameraPath("camera3",1200,250,sniper4) or CameraCancelled() then
			camera3 = false
			camera4 = true
		end
	end
	
	if camera4 then
		if CameraPath("camera4",1200,500,prison1) or CameraCancelled() then
			camera4 = false
			camera5 = true
			audmsg = AudioMessage("spacer8.wav")
		end
	end

    if camera5 then
		if CameraObject(scavenger,1200,1200,2000,scavenger) or CameraCancelled() or IsAudioMessageDone(audmsg) then
			camera5 = false
			CameraFinish()
			ClearObjectives()
			AddObjective("omegam08.otf", "WHITE")
		end
	end
---------------------------------------------------------
-------- Sniper Objective (goala)
    if not goala and not IsAlive(sniper1) and not IsAlive(sniper2) and not IsAlive(sniper3) and not IsAlive(sniper4) and not IsAlive(sniper5) and not IsAlive(sniper6) and not IsAlive(sniper7) then
        goala = true
        Objectives()
    end
-------- Stealing Scav (goalb)    
    if GetTeamNum(scavenger)==1 and not goalb then
        goalb = true
        Objectives()
    end
    if GetTeamNum(scavenger2)==1 and not goalb then
        goalb = true
        Objectives()
    end
 -------- Getting Scrap (goalc) 
    if GetScrap(1)>=4.0 and not goalc then
        goalc = true
        Objectives()
    end
-------- Bdog Reinforcements (goalh)
    if not IsAlive(silo) and not goalh and goalc then
        goalh = true
        attacker = BuildObject("bvtank",1,"reinforcements")
        Goto(attacker,"reinforcements_goto",1)
        attacker = BuildObject("bvtank",1,"reinforcements")
        Goto(attacker,"reinforcements_goto",1)
        attacker = BuildObject("bvrazo1",1,"reinforcements")
        Goto(attacker,"reinforcements_goto",1)
    end
-------- Rescuing Pilots (goald and e)
    if not IsAlive(prison1) and not goald then
        goald = true
        BuildObject("asprisnr",1,"prisoner4")
        BuildObject("asprisnr",1,"prisoner5")
        BuildObject("asprisnr",1,"prisoner6")
    end
    
    if not IsAlive(prison2) and not goale then
        goale = true
        BuildObject("asprisnr",1,"prisoner1")
        BuildObject("asprisnr",1,"prisoner2")
        BuildObject("asprisnr",1,"prisoner3")
    end
    
    if not IsAlive(prison1) and not IsAlive(prison2) and not goalg then
        goalg = true
        Objectives()
    end

-------- Killing the Base (goal)   
    if not IsAlive(ccarecy) and not goalf then
        goalf = true
        ClearObjectives()
        AddObjective("omegam08.otf", "GREEN")
        mission_won = true
        audmsg = AudioMessage("spacer8.wav")
    end	
	
---------------------------------------------------------
--Mission Completion
--
    if mission_won and IsAudioMessageDone(audmsg) then
            SucceedMission(GetTime(),"omegm08w.des")
    end
    
    if mission_lost and IsAudioMessageDone(audmsg) then
            FailMission(GetTime(),"omegm08f.des")
    end
end


