local mission_won=false
local mission_lost=false
local goala=false
local goalb=false
local goalc=false
local goald=false
local goale=false
local goalf=false
local goalg=false
local goalh=false
local startup_done=false
local camera1=false
local camera2=false
local camera3=false



--Resupply Enemy Production Vars
local resupply_period=600.0
local resupply_timer=0.0
local audmsg=0

local player=nil
local myrecy=nil
local nsdfrecy=nil
local nsdffact=nil
local nsdfarmo=nil
local outpost1=nil
local outpost2=nil
local outpost3=nil
local attacker=nil
local guard1=nil
local guard2=nil
local guard3=nil
local guard4=nil
local guard5=nil
local guard6=nil
local guard7=nil


function Save()
	return 
		-- bools
		mission_won,mission_lost,goala,goalb,goalc,goald,goale,goalf,goalg,goalh,startup_done,camera1,camera2,camera3,
		-- floats
		resupply_period,resupply_timer,
		-- handles
        player,myrecy,nsdfrecy,nsdffact,nsdfarmo,outpost1,outpost2,outpost3,attacker,guard1,guard2,guard3,guard4,guard5,guard6,guard7,
		-- ints
		audmsg
    end

function Load(...)
	if select('#', ...) > 0 then
		-- bools
		mission_won,mission_lost,goala,goalb,goalc,goald,goale,goalf,goalg,goalh,startup_done,camera1,camera2,camera3,
		-- floats
		resupply_period,resupply_timer,
		-- handles
        player,myrecy,nsdfrecy,nsdffact,nsdfarmo,outpost1,outpost2,outpost3,attacker,guard1,guard2,guard3,guard4,guard5,guard6,guard7,
		-- ints
		audmsg
		= ...
	end
end

function PostLoad()
end



function Update ()

    SetAIP("dragonm1.aip", 2)--sets the AIP file for team 3.
    --SetPilot (2, 20) --This gives team 2 20 pilots.
    --SetScrap (2, 50) --This gives team 2 50 scrap.
    
    player=GetPlayerHandle()
    myrecy=GetHandle("cvrecyd1402_recycler")
    nsdfrecy=GetHandle("avrecy0_recycler")
    nsdffact=GetHandle("avmuf0_factory")
    nsdfarmo=GetHandle("")
    outpost1=GetHandle("absilo7_scrapsilo")
    outpost2=GetHandle("absilo101_scrapsilo")
    outpost3=GetHandle("absilo4_scrapsilo")
    
    
    

--------------------------------------------------------
--Startup and Camera
--
    if not startup_done then
        startup_done = true
        camera1=true
        goald=true
        CameraReady()
        guard1=GetHandle("avltnk5_wingman")
        guard2=GetHandle("avtank4_wingman")
        guard3=GetHandle("avtank3_wingman")
        guard4=GetHandle("avtank2_wingman")
        guard5=GetHandle("avrckt5_wingman")
        guard6=GetHandle("avfigh5_wingman")
        guard7=GetHandle("avfigh4_wingman")
    end
    
    if camera1 then
		if CameraPath("camera1",300,1600,player) or CameraCancelled() then
			camera1 = false
			camera2 = true
			audmsg=AudioMessage("spacer8.wav")
		end
	end
	if camera2 then
		if CameraObject(nsdfrecy,-2000.0,2000.0,5000.0,nsdfrecy) or CameraCancelled() or IsAudioMessageDone(audmsg) then
			camera2 = false
			CameraFinish()
			StartCockpitTimer(240.0,150.0,120.0)
		end
	end

--------------------------------------------------------	
-- AI Resupply Timer
-- This gives the AI more pilots and scrap periodically.
	if resupply_timer<resupply_period then
        resupply_timer = resupply_timer + 0.0167
        else
        resupply_timer = 0.0
        AddPilot (2, 60) 
        AddScrap (2, 100)
    end
    
---------------------------------------------------------
--Mission Components
--   
    if GetCockpitTimer()==120.0 and not goala and startup_done and not camera1 and not camera2 then
        goala=true
        SetObjectiveOn(nsdfrecy)
        SetObjectiveOn(nsdffact)
        ClearObjectives()
        if goala and not goalf then
            AddObjective("dragon1B.otf", "YELLOW")
        elseif goala and goalf then
            AddObjective("dragon1B.otf", "GREEN")
        elseif not goala and not goalf then
            AddObjective("dragon1B.otf", "WHITE")
        elseif not goala and goalf then
            AddObjective("dragon1B.otf", "GREEN")    
        end
        if goalb then
            AddObjective("dragon1C.otf", "GREEN")
        else
            AddObjective("dragon1C.otf", "WHITE")
        end
        if goald then
            AddObjective("dragon1D.otf", "YELLOW")
        else
            AddObjective("dragon1D.otf", "WHITE")
        end
    end
    if GetCockpitTimer()==0.0 and not goalg and startup_done and not camera1 and not camera2 then
        goalg=true
        HideCockpitTimer()
    end
    if GetDistance(player,"hospital_base")<300.0 and goalc and not goald then
        goalc=false
        goald=true
        ClearObjectives()
        if goala and not goalf then
            AddObjective("dragon1B.otf", "YELLOW")
        elseif goala and goalf then
            AddObjective("dragon1B.otf", "GREEN")
        elseif not goala and not goalf then
            AddObjective("dragon1B.otf", "WHITE")
        elseif not goala and goalf then
            AddObjective("dragon1B.otf", "GREEN")    
        end
        if goalb then
            AddObjective("dragon1C.otf", "GREEN")
        else
            AddObjective("dragon1C.otf", "WHITE")
        end
        if goald then
            AddObjective("dragon1D.otf", "YELLOW")
        else
            AddObjective("dragon1D.otf", "WHITE")
        end
    end
    if GetDistance(player,"hospital_base")>300.0 and goald and not goalc then
        goalc=true
        goald=false
        ClearObjectives()
        if goala and not goalf then
            AddObjective("dragon1B.otf", "YELLOW")
        elseif goala and goalf then
            AddObjective("dragon1B.otf", "GREEN")
        elseif not goala and not goalf then
            AddObjective("dragon1B.otf", "WHITE")
        elseif not goala and goalf then
            AddObjective("dragon1B.otf", "GREEN")    
        end
        if goalb then
            AddObjective("dragon1C.otf", "GREEN")
        else
            AddObjective("dragon1C.otf", "WHITE")
        end
        if goald then
            AddObjective("dragon1D.otf", "YELLOW")
        else
            AddObjective("dragon1D.otf", "WHITE")
        end
    end
    if not IsAlive(myrecy) and not goale then
        goale=true
        audmsg=AudioMessage("spacer5.wav")
        mission_lost=true
        ClearObjectives()
        AddObjective("dragonm1.otf", "RED")
    end
    if not IsAlive(nsdfrecy) and not IsAlive(nsdffact) and not goalf then
        goalf=true
        SetObjectiveOn(outpost1)
        SetObjectiveOn(outpost2)
        SetObjectiveOn(outpost3)
        ClearObjectives()
        if goala and not goalf then
            AddObjective("dragon1B.otf", "YELLOW")
        elseif goala and goalf then
            AddObjective("dragon1B.otf", "GREEN")
        elseif not goala and not goalf then
            AddObjective("dragon1B.otf", "WHITE")
        elseif not goala and goalf then
            AddObjective("dragon1B.otf", "GREEN")    
        end
        if goalb then
            AddObjective("dragon1C.otf", "GREEN")
        else
            AddObjective("dragon1C.otf", "WHITE")
        end
        if goald then
            AddObjective("dragon1D.otf", "YELLOW")
        else
            AddObjective("dragon1D.otf", "WHITE")
        end
    end
    if goalf and not IsAlive(outpost1)and not IsAlive(outpost2)and not IsAlive(outpost3) and not goalb then
        goalb=true
        ClearObjectives()
        if goala and not goalf then
            AddObjective("dragon1B.otf", "YELLOW")
        elseif goala and goalf then
            AddObjective("dragon1B.otf", "GREEN")
        elseif not goala and not goalf then
            AddObjective("dragon1B.otf", "WHITE")
        elseif not goala and goalf then
            AddObjective("dragon1B.otf", "GREEN")    
        end
        if goalb then
            AddObjective("dragon1C.otf", "GREEN")
        else
            AddObjective("dragon1C.otf", "WHITE")
        end
        if goald then
            AddObjective("dragon1D.otf", "YELLOW")
        else
            AddObjective("dragon1D.otf", "WHITE")
        end
        audmsg=AudioMessage("spacer5.wav")
        mission_won=true
        ClearObjectives()
        AddObjective("dragonm1.otf", "GREEN")
    end
    if not goalh and GetDistance(nsdfrecy,"release")<300.0 then
        goalh=true
        Stop(guard1,0)
        Stop(guard2,0)
        Stop(guard3,0)
        Stop(guard4,0)
        Stop(guard5,0)
        Stop(guard6,0)
        Stop(guard7,0)
    end
        
---------------------------------------------------------
--Mission Completion
--
    if mission_won and IsAudioMessageDone(audmsg) then
            SucceedMission(GetTime(),"dragon1w.des")
    end
    
    if mission_lost and IsAudioMessageDone(audmsg) then
            FailMission(GetTime(),"dragon1f.des")
    end
end


