require "math"

local mission_won=false
local mission_lost=false
local goala=false
local goalb=false
local goalc=false
local goald=false
local goale=false
local goalf=false
local goalg=false
local goalh=false
local goali=false
local goalj=false
local startup_done=false
local camera1=false
local camera2=false
local camera3=false
local camera4=false
local haulpickup=false

--Resupply Enemy Production Vars
local resupply_period=600.0
local resupply_timer=0.0
local soldier_period=450.0
local soldier_timer=0.0

local audmsg=0

local player=nil
local myrecy=nil
local ccarecy=nil
local ccafact1=nil
local ccafact2=nil
local ccaarmo=nil
local techa=nil
local techb=nil
local techc=nil
local attacker=nil
local haul1=nil
local haul2=nil
local haul3=nil
local haul2trig1=nil
local haul2trig2=nil
local haul2trig3=nil
local haul2trig4=nil
local soldier1barr=nil
local soldier3barr=nil
local soldier4barr=nil
local soldier5barr=nil
local soldier6barr=nil
local soldier7barr=nil
local soldier8barr=nil
local soldier9barr=nil
local soldier11barr=nil
local lpad=nil

local soldierTable = {}
local apcTable = {}



function Save()
	return 
		-- bools
		mission_won,mission_lost,goala,goalb,goalc,goald,goale,goalf,goalg,goalh,goali,goalj,startup_done,camera1,camera2,camera3,camera4,haulpickup,
		-- floats
		resupply_period,resupply_timer,soldier_period,soldier_timer,
		-- handles
        player,myrecy,ccarecy,ccafact1,ccafact2,ccaarmo,techa,techb,techc,attacker,haul1,haul2,haul3,haul2trig1,haul2trig2,haul2trig3,haul2trig4,
        --[[soldierTable,apcTable,]]soldier1barr,soldier3barr,soldier4barr,soldier5barr,soldier6barr,soldier7barr,soldier8barr,soldier9barr,soldier11barr,lpad,
		-- ints
		audmsg
    end

function Load(...)
	if select('#', ...) > 0 then
		-- bools
		mission_won,mission_lost,goala,goalb,goalc,goald,goale,goalf,goalg,goalh,goali,goalj,startup_done,camera1,camera2,camera3,camera4,haulpickup,
		-- floats
		resupply_period,resupply_timer,soldier_period,soldier_timer,
		-- handles
        player,myrecy,ccarecy,ccafact1,ccafact2,ccaarmo,techa,techb,techc,attacker,haul1,haul2,haul3,haul2trig1,haul2trig2,haul2trig3,haul2trig4,
        --[[soldierTable,apcTable,]]soldier1barr,soldier3barr,soldier4barr,soldier5barr,soldier6barr,soldier7barr,soldier8barr,soldier9barr,soldier11barr,lpad,
		-- ints
		audmsg
		= ...
	end
end

function PostLoad()
end

function Objectives()
    ClearObjectives()
    if goald then
        AddObjective("dragon3B.otf","GREEN")
        else
        AddObjective("dragon3B.otf","WHITE")
    end
    if goale then
        AddObjective("dragon3C.otf","GREEN")
        else
        AddObjective("dragon3C.otf","WHITE")
    end
    if goalh and not goala then
        AddObjective("dragon3D.otf","YELLOW")
    end
    if goala then
        AddObjective("dragon3G.otf","GREEN")
    end
    if goali and not goalb then
        AddObjective("dragon3E.otf","YELLOW")
    end
    if goalb then
        AddObjective("dragon3H.otf","GREEN")
    end
    if goalj and not goalc then
        AddObjective("dragon3F.otf","YELLOW")
    end
    if goalc then
        AddObjective("dragon3I.otf","GREEN")    
    end
end

function AddObject(h)
    if IsOdf(h,"svapc") then
        for i = 1, # apcTable do
          if not IsAlive(apcTable[i]) then
             table.remove(apcTable, i)
          end
        end
        table.insert(apcTable, h)
    end             
end
    

function Update ()

    SetAIP("dragonm3.aip", 2)--sets the AIP file for team 3.
    --SetPilot (2, 20) --This gives team 2 20 pilots.
    --SetScrap (2, 50) --This gives team 2 50 scrap.
    player=GetPlayerHandle()
    myrecy=GetHandle("cvrecy5_recycler")
    ccarecy=GetHandle("svrecy6_recycler")--will serve as haul1trig1
    ccafact1=GetHandle("svmuf126_factory")--will serve as haul1trig2
    ccafact2=GetHandle("svmuf0_factory")--will serve as haul3trig1
    ccaarmo=GetHandle("svslf6_armory")--will serve as haul3trig2
    haul2trig1=GetHandle("sbtowe36_turret")--gtow on one side
    haul2trig2=GetHandle("sbtowe35_turret")--gtow on one side
    haul2trig3=GetHandle("sbtowe34_turret")--gtow on other side
    haul2trig4=GetHandle("sbtowe33_turret")--gtow on other side
    --if both gtows are destroyed on one side or the other, trigger tug spawn
    techa=GetHandle("sbtecha0_turret")
    techb=GetHandle("sbtechb0_turret")
    techc=GetHandle("sbtechc0_turret")
    soldier1barr=GetHandle("sbbarr13_barracks")
    soldier3barr=GetHandle("sbbarr12_barracks")
    soldier4barr=GetHandle("sbbarr30_barracks")
    soldier5barr=GetHandle("sbbarr11_barracks")
    soldier6barr=GetHandle("sbbarr41_barracks")
    soldier7barr=GetHandle("sbbarr40_barracks")
    soldier8barr=GetHandle("sbbarr39_barracks")
    soldier9barr=GetHandle("sbbarr38_barracks")
    soldier11barr=GetHandle("sbbarr22_barracks")
    lpad=GetHandle("sblpad41_i76building")
    

--------------------------------------------------------
--Startup and Camera
--
    if not startup_done then
        startup_done = true
        camera1=true
        CameraReady()
        SetObjectiveOff(techa)
        SetObjectiveOff(techb)
        SetObjectiveOff(techc)
    end
    
    if camera1 then
		if CameraPath("camera1",1200,500,techa) or CameraCancelled() then
			camera1 = false
			camera2 = true
		end
	end
	if camera2 then
		if CameraPath("camera2",300,500,techb) or CameraCancelled() then
			camera2 = false
			camera3 = true
		end
	end
	if camera3 then
		if CameraPath("camera3",2500,750,techc) or CameraCancelled() then
			camera3 = false
			camera4 = true
		end
	end
	if camera4 then
		if CameraPath("camera4",400,1200,techc) or CameraCancelled() then
			camera4 = false
			CameraFinish()
			ClearObjectives()
			AddObjective("dragonm3.otf","WHITE")
		end
	end

--------------------------------------------------------	
-- AI Resupply Timer
-- This gives the AI more pilots and scrap periodically.
	if resupply_timer<resupply_period then
        resupply_timer = resupply_timer + 0.0167
        else
        resupply_timer = 0.0
        AddPilot (2, 60) 
        AddScrap (2, 100)
    end
--------------------------------------------------------	
-- Soldier Spawn and Attack Timer and Attack Handling
-- This gives the AI more pilots and scrap periodically.
	if soldier_timer<soldier_period then
        soldier_timer = soldier_timer + 0.0167
        else
        soldier_timer = 0.0
        for i = 1, # soldierTable do
          if not IsAlive(soldierTable[i]) then
             table.remove(soldierTable, i)
          end
        end 
        if IsAlive(soldier1barr) then
            table.insert(soldierTable, BuildObject("sssold",2,"soldier_spawn",0))
        end
        if IsAlive(soldier3barr) then
            table.insert(soldierTable, BuildObject("sssold",2,"soldier_spawn",2))
        end
        if IsAlive(soldier4barr) then
            table.insert(soldierTable, BuildObject("sssold",2,"soldier_spawn",3))
        end
        if IsAlive(soldier5barr) then
            table.insert(soldierTable, BuildObject("sssold",2,"soldier_spawn",4))
        end
        if IsAlive(soldier6barr) then
            table.insert(soldierTable, BuildObject("sssold",2,"soldier_spawn",5))
        end
        if IsAlive(soldier7barr) then
            table.insert(soldierTable, BuildObject("sssold",2,"soldier_spawn",6))
        end
        if IsAlive(soldier8barr) then
            table.insert(soldierTable, BuildObject("sssold",2,"soldier_spawn",7))
        end
        if IsAlive(soldier9barr) then
            table.insert(soldierTable, BuildObject("sssold",2,"soldier_spawn",8))
        end
        if IsAlive(soldier11barr) then
            table.insert(soldierTable, BuildObject("sssold",2,"soldier_spawn",10))
        end
        for i = 1, # soldierTable do
              if IsAlive(soldierTable[i]) then
                    Goto(soldierTable[i], "soldier_path")
              end
        end  
    end
    for i = 1, # soldierTable do
          if IsAlive(soldierTable[i]) and GetDistance(soldierTable[i],GetNearestEnemy(soldierTable[i]))<100.0 and GetDistance(soldierTable[i],GetNearestEnemy(soldierTable[i]))>90.0 then
                Attack(soldierTable[i],GetNearestEnemy(soldierTable[i]))
          end
    end  
---------------------------------------------------------
--APC Attack and Table Rebuild After Load
--     
    for i = 1, # apcTable do
          if IsAlive(apcTable[i]) and GetDistance(apcTable[i],GetNearestEnemy(apcTable[i]))<100.0 and not IsDeployed(apcTable[i]) then
                Deploy(apcTable[i])
          end
    end
    if IsOdf(GetNearestEnemy(player),"svapc") and not apcTable[GetNearestEnemy(player)] then
        for i = 1, # apcTable do
          if not IsAlive(apcTable[i]) then
             table.remove(apcTable, i)
          end
        end
        table.insert(apcTable, GetNearestEnemy(player))
    end           
---------------------------------------------------------
--Mission Components
--   
    if not IsValid(techa) and not goala then
        SetObjectiveOff(haul1)
        Goto(haul1,"haul_recourse")
        goala=true
        Objectives()
    end
    if not IsValid(techb) and not goalb then
        SetObjectiveOff(haul2)
        Goto(haul2,"haul_recourse")
        goalb=true
        Objectives()
    end
    if not IsValid(techc) and not goalc then
        SetObjectiveOff(haul3)
        Goto(haul3,"haul_recourse")
        goalc=true
        Objectives()
    end
    if GetDistance(haul1,"haul_recourse")<20.0 and IsAlive(lpad) then
        RemoveObject(haul1)
    end
    if GetDistance(haul2,"haul_recourse")<20.0 and IsAlive(lpad) then
        RemoveObject(haul1)
    end
    if GetDistance(haul3,"haul_recourse")<20.0 and IsAlive(lpad) then
        RemoveObject(haul1)
    end
    if goala and goalb and goalc and not goald then
        goald=true
        Objectives()
    end
    if not IsAlive(ccarecy) and not IsAlive(ccafact1) and not IsAlive(ccafact2) and not IsAlive(ccaarmo) and not goale then
        goale=true
        Objectives()
    end
    if goald and goale and not goalg then
        goalg=true
        ClearObjectives()
        Objectives()
        audmsg=AudioMessage("spacer5.wav")
        mission_won=true
    end    
---------------------------------------------------------
--Tug Handling
-- 
    if not IsAlive(ccarecy) and not IsAlive(ccafact1) and not goalh then
        haulpickup=false
        goalh=true
        SetObjectiveOn(techa)
        Objectives()
        haul1=BuildObject("svhaul",2,"tug_spawn")
        Pickup(haul1,techa,1)
        attacker=BuildObject("svtank",2,"attacker1_spawn")
        Defend2(attacker,haul1,1)
        attacker=BuildObject("svltnk",2,"attacker2_spawn")
        Defend2(attacker,haul1,1)
        SetObjectiveOn(haul1)
   end
   if HasCargo(haul1) and not haulpickup then
        haulpickup=true
        Goto(haul1,"tug_spawn",1)
        Goto(haul2,"tug_spawn",1)
        Goto(haul3,"tug_spawn",1)
   end
   if GetDistance(techa,"tug_spawn")<50.0 and not goalf then
        goalf=true
        audmsg=AudioMessage("spacer5.wav")
        ClearObjectives()
        if goald then
            AddObjective("dragon3B.otf","GREEN")
            else
            AddObjective("dragon3B.otf","WHITE")
        end
        if goale then
            AddObjective("dragon3c.otf","GREEN")
            else
            AddObjective("dragon3c.otf","WHITE")
        end
        AddObjective("dragon3D.otf","RED")
        mission_lost=true
   end
---------------------------------------------------------  
   if not IsAlive(haul2trig1) and not IsAlive(haul2trig2) and not goali then
        haulpickup=false
        goali=true
        SetObjectiveOn(techb)
        Objectives()
        haul2=BuildObject("svhaul",2,"tug_spawn")
        Pickup(haul2,techb,1)
        attacker=BuildObject("svtank",2,"attacker1_spawn")
        Defend2(attacker,haul2,1)
        attacker=BuildObject("svltnk",2,"attacker2_spawn")
        Defend2(attacker,haul2,1)
        SetObjectiveOn(haul2)
   end
   if not IsAlive(haul2trig3) and not IsAlive(haul2trig4) and not goali then
        haulpickup=false
        goali=true
        SetObjectiveOn(techb)
        Objectives()
        haul2=BuildObject("svhaul",2,"tug_spawn")
        Pickup(haul2,techb,1)
        attacker=BuildObject("svtank",2,"attacker1_spawn")
        Defend2(attacker,haul2,1)
        attacker=BuildObject("svltnk",2,"attacker2_spawn")
        Defend2(attacker,haul2,1)
        SetObjectiveOn(haul2)
   end
   if HasCargo(haul2) and not haulpickup then
        haulpickup=true
        Goto(haul1,"tug_spawn",1)
        Goto(haul2,"tug_spawn",1)
        Goto(haul3,"tug_spawn",1)
   end
   if GetDistance(techb,"tug_spawn")<50.0 and not goalf then
        goalf=true
        audmsg=AudioMessage("spacer5.wav")
        ClearObjectives()
        if goald then
            AddObjective("dragon3B.otf","GREEN")
            else
            AddObjective("dragon3B.otf","WHITE")
        end
        if goale then
            AddObjective("dragon3c.otf","GREEN")
            else
            AddObjective("dragon3c.otf","WHITE")
        end
        AddObjective("dragon3D.otf","RED")
        mission_lost=true
   end
---------------------------------------------------------     
if not IsAlive(ccafact2) and not IsAlive(ccaarmo) and not goalj then
        haulpickup=false
        goalj=true
        SetObjectiveOn(techc)
        Objectives()
        haul3=BuildObject("svhaul",2,"tug_spawn")
        Pickup(haul3,techc,1)
        attacker=BuildObject("svtank",2,"attacker1_spawn")
        Defend2(attacker,haul3,1)
        attacker=BuildObject("svltnk",2,"attacker2_spawn")
        Defend2(attacker,haul3,1)
        SetObjectiveOn(haul3)
   end
   if HasCargo(haul3) and not haulpickup then
        haulpickup=true
        Goto(haul1,"tug_spawn",1)
        Goto(haul2,"tug_spawn",1)
        Goto(haul3,"tug_spawn",1)
   end
   if GetDistance(techc,"tug_spawn")<50.0 and not goalf then
        goalf=true
        audmsg=AudioMessage("spacer5.wav")
        ClearObjectives()
        if goald then
            AddObjective("dragon3B.otf","GREEN")
            else
            AddObjective("dragon3B.otf","WHITE")
        end
        if goale then
            AddObjective("dragon3c.otf","GREEN")
            else
            AddObjective("dragon3c.otf","WHITE")
        end
        AddObjective("dragon3D.otf","RED")
        mission_lost=true
   end  
    
---------------------------------------------------------
--Mission Completion
--
    if mission_won and IsAudioMessageDone(audmsg) then
            SucceedMission(GetTime(),"dragon3w.des")
    end
    
    if mission_lost and IsAudioMessageDone(audmsg) then
            FailMission(GetTime(),"dragon3f.des")
    end
end


