local mission_won=false
local mission_lost=false
local goala=false
local goalb=false
local goalc=false
local goald=false
local goale=false
local goalf=false
local goalg=false
local goalh=false
local startup_done=false
local camera1=false
local camera2=false
local camera3=false



--Resupply Enemy Production Vars
local resupply_period=600.0
local resupply_timer=0.0
local audmsg=0

local apcTable = {}

local player=nil
local myrecy=nil
local nsdfrecy=nil
local nsdffact=nil
local nsdfarmo=nil
local outpost1=nil
local outpost2=nil
local outpost3=nil
local attacker=nil
local gtow1=nil
local gtow2=nil
local gtow3=nil

function Save()
	return 
		-- bools
		mission_won,mission_lost,goala,goalb,goalc,goald,goale,goalf,goalg,goalh,startup_done,camera1,camera2,camera3,
		-- floats
		resupply_period,resupply_timer,
		-- handles
        player,myrecy,nsdfrecy,nsdffact,nsdfarmo,outpost1,outpost2,outpost3,attacker,gtow1,gtow2,gtow3,--[[apcTable,]]
		-- ints
		audmsg
    end

function Load(...)
	if select('#', ...) > 0 then
		-- bools
		mission_won,mission_lost,goala,goalb,goalc,goald,goale,goalf,goalg,goalh,startup_done,camera1,camera2,camera3,
		-- floats
		resupply_period,resupply_timer,
		-- handles
        player,myrecy,nsdfrecy,nsdffact,nsdfarmo,outpost1,outpost2,outpost3,attacker,gtow1,gtow2,gtow3,--[[apcTable,]]
		-- ints
		audmsg
		= ...
	end
end

function PostLoad()
end

function Objectives()
    ClearObjectives()
    if goala and IsDeployed(myrecy) then
        AddObjective("dragon5B.otf", "GREEN")
        else
        AddObjective("dragon5B.otf", "WHITE")
    end
    if goalb then
        AddObjective("dragon5C.otf", "GREEN")
        else
        AddObjective("dragon5C.otf", "WHITE")
    end
    if goalc then
        AddObjective("dragon5D.otf", "GREEN")
        else
        AddObjective("dragon5D.otf", "WHITE")
    end
end

function AddObject(h)
    if IsOdf(h,"cbtowe") and not IsAlive(gtow1) then
        gtow1=h
    elseif IsOdf(h,"cbtowe") and IsAlive(gtow1) and not IsAlive(gtow2) then
        gtow2=h
    elseif IsOdf(h,"cvmuf") and IsAlive(gtow1) and IsAlive(gtow2) and not IsAlive(gtow3) then
        gtow3=h
    end
    
    if IsOdf(h,"bvapc") then
        for i = 1, # apcTable do
          if not IsAlive(apcTable[i]) then
             table.remove(apcTable, i)
          end
        end
        table.insert(apcTable, h)
    end  
end

function Update ()

    SetAIP("dragonm5.aip", 2)--sets the AIP file for team 3.
    --SetPilot (2, 20) --This gives team 2 20 pilots.
    --SetScrap (2, 50) --This gives team 2 50 scrap.
    player=GetPlayerHandle()
    nsdfrecy=GetHandle("bvrecyo7132_recycler")
    nsdffact=GetHandle("bvmufo7132_factory")
    nsdfarmo=GetHandle("bvslf1_armory")
    myrecy=GetHandle("cvrecy0_recycler")

--------------------------------------------------------
--Startup and Camera
--
    if not startup_done then
        startup_done = true
    end
    
   

--------------------------------------------------------	
-- AI Resupply Timer
-- This gives the AI more pilots and scrap periodically.
	if resupply_timer<resupply_period then
        resupply_timer = resupply_timer + 0.0167
        else
        resupply_timer = 0.0
        AddPilot (2, 60) 
        AddScrap (2, 140)
    end
    
    
--------------------------------------------------------	
-- APC Business
-- Makes APCs deploy when theny get near enemies.  
    for i = 1, # apcTable do
          if IsAlive(apcTable[i]) and GetDistance(apcTable[i],GetNearestEnemy(apcTable[i]))<100.0 and not IsDeployed(apcTable[i]) then
                Deploy(apcTable[i])
          end
    end 
    if IsOdf(GetNearestEnemy(player),"bvapc") and not apcTable[GetNearestEnemy(player)] then
        for i = 1, # apcTable do
          if not IsAlive(apcTable[i]) then
             table.remove(apcTable, i)
          end
        end
        table.insert(apcTable, GetNearestEnemy(player))
    end      
---------------------------------------------------------
--Mission Components
--   
    if not goala and IsDeployed(myrecy) then
        goala=true
        Objectives()
    end
    
    if not goalb and IsAlive(gtow1)and IsAlive(gtow2)and IsAlive(gtow3) then
        goalb=true
        Objectives()
    end
    
    if not goalc and not IsAlive(nsdfrecy) and not IsAlive(nsdffact) and not IsAlive(nsdfarmo) then
        goalc=true
        Objectives()
        audmsg=AudioMessage("spacer5.wav")
        mission_won=true
    end
   
    
---------------------------------------------------------
--Mission Completion
--
    if mission_won and IsAudioMessageDone(audmsg) then
            SucceedMission(GetTime(),"dragon5w.des")
    end
    
    if mission_lost and IsAudioMessageDone(audmsg) then
            FailMission(GetTime(),"dragon5f.des")
    end
end


