local mission_won=false
local mission_lost=false
local goala=false
local goalb=false
local goalc=false
local goald=false
local goale=false
local goalf=false
local goalg=false
local goalh=false
local startup_done=false
local camera1=false
local camera2=false
local camera3=false
local camera4=false



--Resupply Enemy Production Vars
local resupply_period=720.0
local resupply_timer=0.0
local audmsg=0

local player=nil
local myrecy=nil
local nsdfrecy=nil
local nsdffact=nil
local nsdfarmo=nil
local lpad=nil
local satellite=nil
local prison1=nil
local prison2=nil
local prison3=nil
local prison4=nil
local jailmin=nil
local attacker=nil

function Save()
	return 
		-- bools
		mission_won,mission_lost,goala,goalb,goalc,goald,goale,goalf,goalg,goalh,startup_done,camera1,camera2,camera3,camera4,
		-- floats
		resupply_period,resupply_timer,
		-- handles
        player,myrecy,nsdfrecy,nsdffact,nsdfarmo,lpad,satellite,prison1,prison2,prison3,prison4,attacker,jailmin,
		-- ints
		audmsg
    end

function Load(...)
	if select('#', ...) > 0 then
		-- bools
		mission_won,mission_lost,goala,goalb,goalc,goald,goale,goalf,goalg,goalh,startup_done,camera1,camera2,camera3,camera4,
		-- floats
		resupply_period,resupply_timer,
		-- handles
        player,myrecy,nsdfrecy,nsdffact,nsdfarmo,lpad,satellite,prison1,prison2,prison3,prison4,attacker,jailmin,
		-- ints
		audmsg
		= ...
	end
end

function PostLoad()
end

function Objectives()
    ClearObjectives()
    if goala then
        AddObjective("dragon6B.otf","GREEN")
        else
        AddObjective("dragon6B.otf","WHITE")
    end
    if goalb then
        AddObjective("dragon6C.otf","GREEN")
        else
        AddObjective("dragon6C.otf","WHITE")
    end
    if goalc then
        AddObjective("dragon6D.otf","GREEN")
        else
        AddObjective("dragon6D.otf","WHITE")
    end
end

function Update ()

    SetAIP("dragonm6.aip", 2)--sets the AIP file for team 3.
    --SetPilot (2, 20) --This gives team 2 20 pilots.
    --SetScrap (2, 50) --This gives team 2 50 scrap.
    player=GetPlayerHandle()
    myrecy=GetHandle("cvrecy0_recycler")
    nsdfrecy=GetHandle("bvrecyo70_recycler")
    nsdffact=GetHandle("bvmufo70_factory")
    lpad=GetHandle("cblpad13_i76building")
    satellite=GetHandle("bbcom30_commtower")
    prison1=GetHandle("bbhango11_repairdepot")
    prison2=GetHandle("abbarr1_barracks")
    prison3=GetHandle("abbarr2_barracks")
    prison4=GetHandle("abmbld1_supplydepot")
    jailmin=GetHandle("jailmin4_magnet")

--------------------------------------------------------
--Startup and Camera
--
    if not startup_done then
        startup_done = true
        SetObjectiveOff(lpad)
        camera1=true
        CameraReady()
    end
    
    if camera1 then
		if CameraPath("camera1",1200,250,prison4) or CameraCancelled() then
			camera1 = false
			camera2 = true
			--CameraFinish()
		end
	end
    if camera2 then
		if CameraPath("camera2",1200,250,satellite) or CameraCancelled() then
			camera2 = false
			camera3 = true
			Goto(myrecy,"recy_goto")
			--CameraFinish()
		end
	end
	if camera3 then
		if CameraPath("camera3",1200,250,myrecy) or CameraCancelled() then
			camera3 = false
			camera4 = true
			--CameraFinish()
		end
	end
	if camera4 then
		if CameraPath("camera4",1200,250,lpad) or CameraCancelled() then
			camera4 = false
			CameraFinish()
			ClearObjectives()
			AddObjective("dragonm6.otf","WHITE")
		end
	end
--------------------------------------------------------	
-- AI Resupply Timer
-- This gives the AI more pilots and scrap periodically.
	if resupply_timer<resupply_period then
        resupply_timer = resupply_timer + 0.0167
        else
        resupply_timer = 0.0
        AddPilot (2, 60) 
        AddScrap (2, 100)
    end
    
---------------------------------------------------------
--Mission Components
--   
    if not goala and not IsAlive(prison1) or not IsAlive(prison2) or not IsAlive(prison3) or not IsAlive(prison4) then
        SetObjectiveOff(prison4)
        goala=true
        RemoveObject(jailmin)
        Objectives()
    end
    if not goalb and not IsAlive(nsdfrecy) and not IsAlive(nsdffact) then
        SetObjectiveOn(lpad)
        goalb=true
        Objectives()
    end
    if goala and goalb and not goalc and GetDistance(lpad,myrecy)<100.0 and GetDistance(lpad,player)<200.0 then
        goalc=true
        SetObjectiveOff(lpad)
        Objectives()
    end
    if goala and goalb and goalc and not goald then
        audmsg=AudioMessage("spacer5.wav")
        mission_won=true
        goald=true
        Objectives()
    end
    if not IsAlive(myrecy) and not goale then
        goale=true
        ClearObjectives()
        AddObjective("dragonm6.otf", "RED")
        audmsg=AudioMessage("spacer5.wav")
        mission_lost=true
    end
    
---------------------------------------------------------
--Mission Completion
--
    if mission_won and IsAudioMessageDone(audmsg) then
            SucceedMission(GetTime(),"dragon6w.des")
    end
    
    if mission_lost and IsAudioMessageDone(audmsg) then
            FailMission(GetTime(),"dragon6f.des")
    end
end


