local mission_won=false
local mission_lost=false
local goala=false
local goalb=false
local goalc=false
local goald=false
local goale=false
local goalf=false
local goalg=false
local goalh=false
local goali=false
local goalj=false
local startup_done=false

--Resupply Enemy Production Vars
local resupply_period=600.0
local resupply_timer=0.0
local recycler_period=720.0--720.0
local recycler_timer=0.0
local audmsg=0

local apcTable = {}

local player=nil
local myrecy=nil
local nsdfrecy1=nil
local nsdffact1=nil
local nsdfrecy2=nil
local nsdffact2=nil
local bdogrecy=nil
local bdogfact=nil
local facility1=nil
local facility2=nil
local facility3=nil
local attacker=nil
local homebasearmo=nil
local bdogguard1=nil
local bdogguard2=nil
local bdogguard3=nil
local bdogguard4=nil


function Save()
	return 
		-- bools
		mission_won,mission_lost,goala,goalb,goalc,goald,goale,goalf,goalg,goalh,goali,goalj,startup_done,
		-- floats
		resupply_period,resupply_timer,recycler_period,recycler_timer,
		-- handles
        player,myrecy,nsdfrecy1,nsdffact1,nsdfrecy2,nsdffact2,bdogrecy,bdogfact,facility1,facility2,facility3,attacker,--[[apcTable,]]homebasearmo,bdogguard1,bdogguard2,bdogguard3,bdogguard4,
		-- ints
		audmsg
    end

function Load(...)
	if select('#', ...) > 0 then
		-- bools
		mission_won,mission_lost,goala,goalb,goalc,goald,goale,goalf,goalg,goalh,goali,goalj,startup_done,
		-- floats
		resupply_period,resupply_timer,recycler_period,recycler_timer,
		-- handles
        player,myrecy,nsdfrecy1,nsdffact1,nsdfrecy2,nsdffact2,bdogrecy,bdogfact,facility1,facility2,facility3,attacker,--[[apcTable,]]homebasearmo,bdogguard1,bdogguard2,bdogguard3,bdogguard4,
		-- ints
		audmsg
		= ...
	end
end

function PostLoad()
end

function AddObject(h)
    if IsOdf(h,"avapc") or IsOdf(h,"bvapc") then
        for i = 1, # apcTable do
          if not IsAlive(apcTable[i]) then
             table.remove(apcTable, i)
          end
        end
        table.insert(apcTable, h)
    end  
    if IsOdf(h,"avmuf") and GetTeamNum(h)==2 and not IsAlive(nsdffact1) then
        nsdffact1=h
        if goald then
            SetObjectiveOn(nsdffact1)
        end
    end
    if IsOdf(h,"avmuf") and GetTeamNum(h)==3 and not IsAlive(nsdffact2) then
        nsdffact2=h
        if goald then
            SetObjectiveOn(nsdffact2)
        end
    end
end

function Objectives()
    ClearObjectives()
    if goale then
        AddObjective("dragonm7.otf", "GREEN")
        else
        AddObjective("dragonm7.otf", "WHITE")
    end
    if goala then
        AddObjective("dragon7B.otf", "GREEN")
    elseif IsAlive(nsdfrecy1) then
        AddObjective("dragon7B.otf", "WHITE")
    end
    if goalb and goali then
        AddObjective("dragon7C.otf", "GREEN")
    elseif IsAlive(nsdfrecy2) then
        AddObjective("dragon7C.otf", "WHITE")
    end
    if goalg then
        AddObjective("dragon7D.otf", "WHITE")
    end
    if goalc then
        AddObjective("dragon7D.otf", "GREEN")
    end
    if goald then
        AddObjective("dragon7E.otf", "GREEN")
    end
end


    SetAIControl(2, true)
    SetAIControl(3, true)
    SetAIControl(4, true)

function Update ()

    SetAIP("dragon7a.aip", 2)--sets the AIP file for team 2.
    SetAIP("dragon7b.aip", 3)--sets the AIP file for team 3.
    SetAIP("dragon7c.aip", 4)--sets the AIP file for team 4.
    --SetPilot (2, 20) --This gives team 2 20 pilots.
    --SetScrap (2, 50) --This gives team 2 50 scrap.
    
    player=GetPlayerHandle()
    
--------------------------------------------------------
--Startup and Camera
--
    if not startup_done then
        startup_done = true
        SetObjectiveOn(facility1)
        Ally(2,3)
        Ally(2,4)
        Ally(3,4)
        AddPilot (2, 60) 
        AddScrap (2, 50)
        AddPilot (3, 60) 
        AddScrap (3, 50)
        AddPilot (4, 60) 
        AddScrap (4, 50)
        myrecy=GetHandle("cvrecy0_recycler")
        facility1=GetHandle("abrecfac0_repairdepot")
        facility2=GetHandle("abrecfa20_repairdepot")
        facility3=GetHandle("abrecfa21_repairdepot")
        bdogrecy=GetHandle("bvrecy0_recycler")
        bdogfact=GetHandle("bvmuf0_factory")
        nsdfrecy1=GetHandle("avrecy23_recycler")
        nsdffact1=GetHandle("avmuf23_factory")
        homebasearmo=GetHandle("avslf0_armory")
        bdogguard1=GetHandle("bvraz0_wingman")
        bdogguard2=GetHandle("bvraz1_wingman")
        bdogguard3=GetHandle("bvrckt0_wingman")
        bdogguard4=GetHandle("bvtank0_wingman")
    end
     
    if IsAlive(nsdfrecy1) and goala then
        goala=false
        Objectives()
    end 
    if IsAlive(nsdfrecy2) and goalb then
        goalb=false
        Objectives()
    end 
    
--------------------------------------------------------	
-- AI Resupply Timer
-- This gives the AI more pilots and scrap periodically.
	if resupply_timer<resupply_period then
        resupply_timer = resupply_timer + 0.0167
        else
        resupply_timer = 0.0
        AddPilot (2, 60) 
        AddScrap (2, 50)
        AddPilot (3, 60) 
        AddScrap (3, 50)
        AddPilot (4, 60) 
        AddScrap (4, 50)
    end
    if not IsAlive(nsdfrecy1) or not IsAlive(nsdfrecy2) then
        if recycler_timer<recycler_period and IsAlive(facility1) then
            recycler_timer = recycler_timer + 0.0167
            else
            recycler_timer = 0.0
            if not IsAlive(nsdfrecy1) and IsAlive(facility1) then
                nsdfrecy1=BuildObject("avrecy",2,"recycler_spawn")
                Goto(nsdfrecy1,"team2_goto")
            end
            if not IsAlive(nsdfrecy2) and IsAlive(facility1) then
                nsdfrecy2=BuildObject("avrecy",3,"recycler_spawn")
                Goto(nsdfrecy2,"team3_goto")
            end
        end
    end
    
--------------------------------------------------------	
-- APC attack
--   
    for i = 1, # apcTable do
          if IsAlive(apcTable[i]) and GetDistance(apcTable[i],GetNearestEnemy(apcTable[i]))<100.0 and not IsDeployed(apcTable[i]) then
                Deploy(apcTable[i])
          end
    end  
    if IsOdf(GetNearestEnemy(player),"avapc") and not apcTable[GetNearestEnemy(player)] then
        for i = 1, # apcTable do
          if not IsAlive(apcTable[i]) then
             table.remove(apcTable, i)
          end
        end
        table.insert(apcTable, GetNearestEnemy(player))
    end      
    
---------------------------------------------------------
--Mission Components
--  

    if not IsAlive(nsdfrecy1) --[[and not IsAlive(nsdffact1)]] and not goala then
        goala=true
        Objectives()
    end
    
    if not IsAlive(nsdfrecy2) --[[and not IsAlive(nsdffact2)]] and not goalb then
        goalb=true
        Objectives()
    end
    
    
    if not IsAlive(bdogrecy) and not IsAlive(bdogfact) and not goalc then
        goalc=true
        goalg=false
        Objectives()
    end
    
    if GetDistance(bdogrecy,"team4_goto")<200.0 and not goalg then
        goalg=true
        Goto(bdogguard1,"team4_goto",0)
        Goto(bdogguard2,"team4_goto",0)
        Goto(bdogguard3,"team4_goto",0)
        Goto(bdogguard4,"team4_goto",0)
        Objectives()
    end
    
    --
    if not IsAlive(facility2) or not IsAlive(facility3) then
        SetCurHealth(facility1, 0)
    end
    if not IsAlive(facility1) then
        SetCurHealth(facility2, 0)
        SetCurHealth(facility3, 0)
    end
    --
    
    if not IsAlive(facility1) and not goald then
        goald=true
        Objectives()
        SetObjectiveOn(nsdfrecy1)
        SetObjectiveOn(nsdffact1)
        SetObjectiveOn(nsdfrecy2)
        SetObjectiveOn(nsdffact2)
        SetObjectiveOn(bdogrecy)
        SetObjectiveOn(bdogfact)
        SetObjectiveOn(homebasearmo)
    end
    
    if goala and goalb and goalc and goald and not IsAlive(homebasearmo) and not IsAlive(nsdffact1) and not IsAlive(nsdffact2) and not goale then
        goale=true
        ClearObjectives()
        AddObjective("dragonm7.otf","GREEN")
        mission_won=true
        audmsg=AudioMessage("spacer5.wav")
    end
    
    if not IsAlive(myrecy) and not goalf then
        goalf=true
        ClearObjectives()
        AddObjective("dragonm7.otf","RED")
        mission_lost=true
        audmsg=AudioMessage("spacer5.wav")
    end
    
    -----------------------THIS SHOULD BE 400.0 --------------------------------------------------------------------
    if recycler_timer>400.0 and not goali then
        goali=true
    end
    if GetDistance(nsdfrecy1,"team2_goto")<200.0 and not goalj then
        goalj=true
        Objectives()
    end
  
---------------------------------------------------------
--Mission Completion
--
    if mission_won and IsAudioMessageDone(audmsg) then
            SucceedMission(GetTime(),"dragon7w.des")
    end
    
    if mission_lost and IsAudioMessageDone(audmsg) then
            FailMission(GetTime(),"dragon7f.des")
    end
end


