local mission_won=false
local mission_lost=false
local goala=false
local goalb=false
local goalc=false
local goald=false
local goale=false
local goalf=false
local goalg=false
local goalh=false
local startup_done=false
local camera1=false
local camera2=false
local camera3=false
local loading_done=true

local apcTable = {}

--Resupply Enemy Production Vars
local resupply_period=450.0
local resupply_timer=0.0
local audmsg=0

local player=nil
local crarecy=nil
local crafact=nil
local ccafact=nil
local craarmo=nil
local attacker=nil

--APC STUFF
local apca=nil
local apcb=nil
local apcc=nil
local apcgoto=nil
local apctar=nil
local apcguarda=nil
local apcguardb=nil
local apcguardc=nil


function Save()
	return 
		-- bools
		mission_won,mission_lost,goala,goalb,goalc,goald,goale,goalf,goalg,goalh,startup_done,camera1,camera2,camera3,
		-- floats
		resupply_period,resupply_timer,
		-- handles
        player,crarecy,crafact,craarmo,attacker,ccafact,apca,apcb,apcc,apcgoto,apctar,apcguarda,apcguardb,apcguardc,--[[apcTable,]]
		-- ints
		audmsg
    end

function Load(...)
	if select('#', ...) > 0 then
		-- bools
		mission_won,mission_lost,goala,goalb,goalc,goald,goale,goalf,goalg,goalh,startup_done,camera1,camera2,camera3,
		-- floats
		resupply_period,resupply_timer,
		-- handles
        player,crarecy,crafact,craarmo,attacker,ccafact,apca,apcb,apcc,apcgoto,apctar,apcguarda,apcguardb,apcguardc,--[[apcTable,]]
		-- ints
		audmsg
		= ...
		loading_done=false
	end
end

function PostLoad()
end

function AddObject(h)
    if IsOdf(h,"cvapc") then
        for i = 1, # apcTable do
          if not IsAlive(apcTable[i]) then
             table.remove(apcTable, i)
          end
        end
        table.insert(apcTable, h)
    end
end

SetAIControl(2,true)
SetAIControl(3,true)

function Update ()
    
    
    
    --SetPilot (2, 20) --This gives team 2 20 pilots.
    --SetScrap (2, 50) --This gives team 2 50 scrap.
    crarecy=GetHandle("cvrecy11_recycler")
    crafact=GetHandle("cvmuf140_factory")
    craarmo=GetHandle("")
    ccafact=GetHandle("svmuf0_factory")
    

--------------------------------------------------------
--Startup and Camera
--
    
    SetAIP("omegam13.aip", 2)--sets the AIP file for team 3.
    SetAIP("omegm13o.aip", 3)
    if not startup_done then
        startup_done = true
        Ally(2,3)
        AddPilot (2, 60) 
        AddScrap (2, 120)
        AddPilot (3, 60) 
        AddScrap (3, 70)
    end
    if not loading_done then
        loading_done=true
        if goalb then
            UnAlly(2,3)
            else
            Ally(2,3)
        end
    end

--------------------------------------------------------	
-- AI Resupply Timer
-- This gives the AI more pilots and scrap periodically.
	if resupply_timer<resupply_period then
        resupply_timer = resupply_timer + 0.0167
        else
        resupply_timer = 0.0
        AddPilot (2, 60) 
        AddScrap (2, 150)
        AddPilot (3, 60) 
        AddScrap (3, 50)
        if CountUnitsNearObject(ccafact,2000.0,3,"svscav")<5.0 then
            BuildObject("svscav",3,"scavenger_spawn")
        end
    end
    
    for i = 1, # apcTable do
          if IsAlive(apcTable[i]) and GetDistance(apcTable[i],GetNearestEnemy(apcTable[i]))<100.0 and not IsDeployed(apcTable[i]) then
                Deploy(apcTable[i])
          end
    end
    if IsOdf(GetNearestEnemy(player),"cvapc") and not apcTable[GetNearestEnemy(player)] then
        for i = 1, # apcTable do
          if not IsAlive(apcTable[i]) then
             table.remove(apcTable, i)
          end
        end
        table.insert(apcTable, GetNearestEnemy(player))
    end     
---------------------------------------------------------
--Mission Components
--    
    if not IsAlive(crarecy) and not IsAlive(crafact) and not goala then
        goala=true
        ClearObjectives()
        if goala then
            AddObjective("omegm13B.otf", "GREEN")
            else
            AddObjective("omegm13B.otf", "WHITE")
        end
        if goalb then
            AddObjective("omegm13C.otf", "GREEN")
            else
            AddObjective("omegm13C.otf", "WHITE")
        end
        UnAlly(2,3)
     end
     
     if not IsAlive(ccafact) and not goalb then
        goalb=true
        ClearObjectives()
        if goala then
            AddObjective("omegm13B.otf", "GREEN")
            else
            AddObjective("omegm13B.otf", "WHITE")
        end
        if goalb then
            AddObjective("omegm13C.otf", "GREEN")
            else
            AddObjective("omegm13C.otf", "WHITE")
        end
        UnAlly(2,3)
     end
     
    if goala and goalb and not goalc then
        goalc=true
        ClearObjectives()
        if goala then
            AddObjective("omegm13B.otf", "GREEN")
            else
            AddObjective("omegm13B.otf", "WHITE")
        end
        if goalb then
            AddObjective("omegm13C.otf", "GREEN")
            else
            AddObjective("omegm13C.otf", "WHITE")
        end
        audmsg=AudioMessage("spacer8.wav")
		mission_won=true
	end
---------------------------------------------------------
--Mission Completion
--
    if mission_won and IsAudioMessageDone(audmsg) then
            SucceedMission(GetTime(),"omegm13w.des")
    end
    
    if mission_lost and IsAudioMessageDone(audmsg) then
            FailMission(GetTime(),"omegm13f.des")
    end
end


