local mission_won=false
local mission_lost=false
local goala=false
local goalb=false
local goalc=false
local goald=false
local goale=false
local goalf=false
local goalg=false
local goalh=false
local startup_done=false
local camera1=false
local camera2=false
local camera3=false
local camera4=false
local camera5=false


--Resupply Enemy Production Vars
local resupply_period=600.0
local resupply_timer=0.0
local audmsg=0


local player=nil
local crarecy=nil
local crafact=nil
local craarmo=nil
local attacker=nil
local attacker2=nil
local camera1star=nil
local camera2star=nil
local camera3star=nil
local camera4star=nil
local camera5star=nil
local nav1=nil
local nav2=nil
local nav3=nil
local nav4=nil
local nav5=nil
local myrecy=nil

function Save()
	return 
		-- bools
		mission_won,mission_lost,startup_done,goala,goalb,goalc,goald,goale,goalf,goalg,goalh,camera1,camera2,camera3,camera4,camera5,
		-- floats
		resupply_period,resupply_timer,
		-- handles
        player,crarecy,crafact,craarmo,attacker,attacker2,camera1star,camera2star,camera3star,camera4star,camera5star,nav1,nav2,nav3,nav4,nav5,myrecy,
		-- ints
		audmsg
    end

function Load(...)
	if select('#', ...) > 0 then
		-- bools
		mission_won,mission_lost,startup_done,goala,goalb,goalc,goald,goale,goalf,goalg,goalh,camera1,camera2,camera3,camera4,camera5,
		-- floats
		resupply_period,resupply_timer,
		-- handles
        player,crarecy,crafact,craarmo,attacker,attacker2,camera1star,camera2star,camera3star,camera4star,camera5star,nav1,nav2,nav3,nav4,nav5,myrecy,
		-- ints
		audmsg
		= ...
	end
end

function PostLoad()
end



function Update ()

    SetAIP("omegam15.aip", 2)--sets the AIP file for team 3.
    --SetPilot (2, 20) --This gives team 2 20 pilots.
    --SetScrap (2, 50) --This gives team 2 50 scrap.
    player=GetPlayerHandle()
    camera1star=GetHandle("sscr_10_scrap")
    camera2star=GetHandle("eggeizr12_geyser")
    camera3star=GetHandle("absilo1_scrapsilo")
    camera4star=GetHandle("absilo2_scrapsilo")
    camera5star=GetHandle("absilo0_scrapsilo")
    nav1=GetHandle("apcamr107_camerapod")
    nav2=GetHandle("apcamr108_camerapod")
    nav3=GetHandle("apcamr109_camerapod")
    nav4=GetHandle("apcamr110_camerapod")
    nav5=GetHandle("apcamr111_camerapod")
    attacker=GetHandle("cvtnk141_wingman")
    attacker2=GetHandle("cvfigh148_wingman")
    crarecy=GetHandle("cvrecy0_recycler")
    crafact=GetHandle("cvmuf104_factory")
    craarmo=GetHandle("cvslf0_armory")
   
--------------------------------------------------------
--Startup and Camera
--
    if not startup_done then
        startup_done = true
    end
    
    if not goala and GetDistance(attacker2,camera1star)<40.0 then
        goala=true
        ClearObjectives()
        AddObjective("omegm15B.otf","YELLOW")
    end
    
    if not goalb and GetDistance(attacker,camera1star)<40.0 then
        goalb=true
        camera1=true
        CameraReady()
        audmsg = AudioMessage("cornrclk.wav")
    end
    if camera1 then
		if CameraPath("camera1",27000,100,camera1star) or CameraCancelled() then
			camera1 = false
			camera2 = true
			audmsg = AudioMessage("cornrclk.wav")
		end
	end
	if camera2 then
		if CameraPath("camera2",32000,130,camera2star) or CameraCancelled() then
			camera2 = false
			camera3 = true
			audmsg = AudioMessage("cornrclk.wav")
		end
	end
	if camera3 then
		if CameraPath("camera3",26000,100,camera2star) or CameraCancelled() then
			camera3 = false
			camera4 = true
			audmsg = AudioMessage("cornrclk.wav")
		end
	end
	if camera4 then
		if CameraPath("camera4",19000,75,camera2star) or CameraCancelled() then
			camera4 = false
			CameraFinish()
			ClearObjectives()
			AddObjective("omegm15C.otf","WHITE")
			AddObjective("omegm15D.otf","WHITE")
			AddObjective("omegm15E.otf","WHITE")
			StartCockpitTimer(150.0,0.0,0.0)
			goalc = true
		end
	end
	if goala and goalb and goalc and not goald and GetCockpitTimer()==0.0 then
	    goald=true
	    HideCockpitTimer()
	    ClearObjectives()
	    AddObjective("omegm15D.otf","GREEN")
		AddObjective("omegm15E.otf","WHITE")
		myrecy = BuildObject("bvrecyo8",1,"recycler_spawn")
        Goto(myrecy,"recycler_goto",1)
	end
	if not IsAlive(crarecy) and not IsAlive(craarmo) and not IsAlive(crafact) and not goale then
	    goale=true
	    ClearObjectives()
	    AddObjective("omegm15D.otf","GREEN")
		AddObjective("omegm15E.otf","GREEN")
		audmsg=AudioMessage("spacer5.wav")
		mission_won=true
    end
    if goala and goalb and goalc and goald and not IsAlive(myrecy) and not goalf then
        goalf=true
        ClearObjectives()
	    AddObjective("omegm15D.otf","RED")
		AddObjective("omegm15E.otf","RED")
		audmsg=AudioMessage("spacer5.wav")
		mission_lost=true
    end
--------------------------------------------------------	
-- AI Resupply Timer
-- This gives the AI more pilots and scrap periodically.
	if resupply_timer<resupply_period then
        resupply_timer = resupply_timer + 0.0167
        else
        resupply_timer = 0.0
        AddPilot (2, 60) 
        AddScrap (2, 140)
    end
    
---------------------------------------------------------
--Mission Components
--   
    
---------------------------------------------------------
--Mission Completion
--
    if mission_won and IsAudioMessageDone(audmsg) then
            SucceedMission(GetTime(),"omegm15w.des")
    end
    
    if mission_lost and IsAudioMessageDone(audmsg) then
            FailMission(GetTime(),"omegm15f.des")
    end
end


