require "math"

local mission_won=false
local mission_lost=false
local goala=false
local goalb=false
local goalc=false
local goald=false
local goale=false
local goalf=false
local goalg=false
local goalh=false
local goali=false
local startup_done=false
local camera1=false
local camera2=false
local camera3=false
local camera4=false
local camera5=false
local camerareinforcements=false
local loading_done=true

--Resupply Enemy Production Vars
local resupply_period=180.0
local resupply_timer=0.0
local audmsg=0

local reinforcement_options = {}
local sav_options = {}

local player=nil
local crarecy=nil
local crafact=nil
local craarmo=nil
local attacker=nil
local ccarecy=nil
local savhang1=nil
local savsupp1=nil
local savhang2=nil
local savsupp2=nil
local savhang3=nil
local savsupp3=nil
local nav1=nil
local nav2=nil
local nav3=nil
local nav4=nil
local guard1=nil
local guard2=nil
local guard3=nil
local guard4=nil


function Save()
	return 
		-- bools
		mission_won,mission_lost,goala,goalb,goalc,goald,goale,goalf,goalg,goali,goalh,startup_done,camera1,camera2,camera3,camera4,camera5,camerareinforcements,
		-- floats
		resupply_period,resupply_timer,--[[reinforcement_options,sav_options,]]
		-- handles
        player,crarecy,crafact,craarmo,attacker,ccarecy,savhang1,savsupp1,savhang2,savsupp2,savhang3,savsupp3,nav1,nav2,nav3,nav4,guard1,guard2,guard3,guard4,
		-- ints
		audmsg
    end

function Load(...)
	if select('#', ...) > 0 then
		-- bools
		mission_won,mission_lost,goala,goalb,goalc,goald,goale,goalf,goalg,goali,goalh,startup_done,camera1,camera2,camera3,camera4,camera5,camerareinforcements,
		-- floats
		resupply_period,resupply_timer,--[[reinforcement_options,sav_options,]]
		-- handles
        player,crarecy,crafact,craarmo,attacker,ccarecy,savhang1,savsupp1,savhang2,savsupp2,savhang3,savsupp3,nav1,nav2,nav3,nav4,guard1,guard2,guard3,guard4,
		-- ints
		audmsg
		= ...
		loading_done=false
	end
end

function PostLoad()
end

--function reinforce()
--    attacker=BuildObject(reinforcement_options[math.random(# reinforcement_options)], 1, lpad)
--end

function Update ()

    SetAIP("omegam17.aip", 2)--sets the AIP file for team 3.
    --SetPilot (2, 20) --This gives team 2 20 pilots.
    --SetScrap (2, 50) --This gives team 2 50 scrap.
    player=GetPlayerHandle()
    savhang1=GetHandle("hbhang2_repairdepot")
    savsupp1=GetHandle("hbsupp2_supplydepot")
    savhang2=GetHandle("hbhang1_repairdepot")
    savsupp2=GetHandle("hbsupp1_supplydepot")
    savhang3=GetHandle("hbhang0_repairdepot")
    savsupp3=GetHandle("hbsupp0_supplydepot")
    ccarecy=GetHandle("svrecyl0_recycler")
    nav1=GetHandle("apcamr56_camerapod")
    nav2=GetHandle("apcamr57_camerapod")
    nav3=GetHandle("apcamr58_camerapod")
    nav4=GetHandle("apcamrhb0_camerapod")
    
    
    
--------------------------------------------------------
--Startup and Camera
--
    if not startup_done then
        reinforcement_options = {"avhraz", "cvwalk", "cvturr", "cvhaul", "cvcnst", "avmuf", "cvtnk", "avtank", "avtank", "svtank", "avscav", "avscav",
         "svscav", "cvscav", "avtank", "avfigh", "cvfigh", "avfigh", "avltnk", "cvhtnk", "svltnk", "avrckt", "avturr", "bvtank", "bvhraz", "bvturr",
        "cvartl", "svfigh",}
        sav_options = {"hvsav", "hvsav", "hvsat",}
        SetObjectiveOff(GetHandle("apcamr55_camerapod"))
        SetObjectiveOn(ccarecy)
        SetPathLoop("guard1")
        SetPathLoop("guard2")
        SetPathLoop("guard3")
        SetPathLoop("sav_patrol1")
        SetPathLoop("sav_patrol2")
        SetPathLoop("sav_patrol3")
        SetPathLoop("sav_patrol4")
        guard1=GetHandle("hvsat45_wingman")
        guard2=GetHandle("hvsat46_wingman")
        guard3=GetHandle("hvsat47_wingman")
        guard4=GetHandle("hvsat48_wingman")
        Patrol(guard1,"guard1",1)
        Patrol(guard2,"guard2",1)
        Patrol(guard3,"guard3",1)
        Patrol(guard4,"guard3",1)
        startup_done = true
        camera1=true
        CameraReady()
    end
    
    if not loading_done then
        loading_done=true
        reinforcement_options = {"avhraz", "cvwalk", "cvturr", "cvhaul", "cvcnst", "avmuf", "cvtnk", "avtank", "avtank", "svtank", "avscav", "avscav",
         "svscav", "cvscav", "avtank", "avfigh", "cvfigh", "avfigh", "avltnk", "cvhtnk", "svltnk", "avrckt", "avturr", "bvtank", "bvhraz", "bvturr",
        "cvartl", "svfigh",}
        sav_options = {"hvsav", "hvsav", "hvsat",}
    end
        
    
    if camera1 then
		if CameraPath("camera1",1200,750,ccarecy) or CameraCancelled() then
			camera1 = false
			camera2 = true
		end
	end
	if camera2 then
		if CameraPath("camera2",1200,500,savsupp1) or CameraCancelled() then
			camera2 = false
			camera3 = true
		end
	end
	if camera3 then
		if CameraPath("camera3",1200,500,savhang2) or CameraCancelled() then
			camera3 = false
			camera4 = true
		end
	end
	if camera4 then
		if CameraPath("camera4",1200,500,savhang3) or CameraCancelled() then
			camera4 = false
			camera5 = true
		end
	end
	if camera5 then
		if CameraPath("camera5",1200,500,player) or CameraCancelled() then
			camera5 = false
			CameraFinish()
			ClearObjectives()
            AddObjective("omegm17B.otf","WHITE")
            AddObjective("omegm17F.otf","WHITE")
		end
	end
    
    if camerareinforcements then
        if CameraObject(attacker,1200,1200,2000,attacker) or CameraCancelled() or IsAudioMessageDone(audmsg) then
            camerareinforcements = false
            CameraFinish()
        end
    end

--------------------------------------------------------	
-- AI Resupply Timer
-- This gives the AI more pilots and scrap periodically.
	if resupply_timer<resupply_period then
        resupply_timer = resupply_timer + 0.0167
        else
        resupply_timer = 0.0
        attacker=BuildObject(sav_options[math.random(# sav_options)], 2, "sav_spawn1")
        Patrol(attacker,"sav_patrol1",0)
        attacker=BuildObject(sav_options[math.random(# sav_options)], 2, "sav_spawn2")
        Patrol(attacker,"sav_patrol2",0)
        attacker=BuildObject(sav_options[math.random(# sav_options)], 2, "sav_spawn3")
        Patrol(attacker,"sav_patrol3",0)
        attacker=BuildObject(sav_options[math.random(# sav_options)], 2, "sav_spawn2")
        Patrol(attacker,"sav_patrol4",0)
    end
    
---------------------------------------------------------
--Mission Components
--   
    if IsAlive(savhang1) or IsAlive(savsupp1) then
        if not IsAlive(guard1) then
            guard1=BuildObject("hvsat",2,"sav_spawn1")
            Patrol(guard1,"guard1",1)
        end
    end
    if IsAlive(savhang2) or IsAlive(savsupp2) then
        if not IsAlive(guard2) then
            guard2=BuildObject("hvsat",2,"sav_spawn2")
            Patrol(guard2,"guard2",1)
        end
    end
    if IsAlive(savhang3) or IsAlive(savsupp3) then
        if not IsAlive(guard3) then
            guard3=BuildObject("hvsat",2,"sav_spawn3")
            Patrol(guard3,"guard3",1)
        end
        if not IsAlive(guard4) then
            guard4=BuildObject("hvsat",2,"sav_spawn3")
            Patrol(guard4,"guard3",1)
        end
    end
    
    if not goala and GetDistance(ccarecy,player)<200.0 then
        goala=true
        SetObjectiveOff(ccarecy)
        SetObjectiveOn(nav1)
        ClearObjectives()
        if goalc then
            AddObjective("omegm17C.otf","GREEN")
        else
            AddObjective("omegm17C.otf","WHITE")
        end
        if goale then
            AddObjective("omegm17D.otf","GREEN")
        else
            AddObjective("omegm17D.otf","WHITE")
        end
        if goalg then
            AddObjective("omegm17E.otf","GREEN")
        else
            AddObjective("omegm17E.otf","WHITE")
        end
        AddObjective("omegm17F.otf","WHITE")
        attacker=BuildObject(reinforcement_options[math.random(# reinforcement_options)], 1, "reinforcements_spawn1",0)
        Goto(attacker,ccarecy,0)
        attacker=BuildObject(reinforcement_options[math.random(# reinforcement_options)], 1, "reinforcements_spawn1",1)
        Goto(attacker,ccarecy,0)
        attacker=BuildObject(reinforcement_options[math.random(# reinforcement_options)], 1, "reinforcements_spawn1",2)
        Goto(attacker,ccarecy,0)
        audmsg=AudioMessage("spacer5.wav")
        camerareinforcements=true
        CameraReady()
    end
    
    if goala and not goalb and GetDistance(ccarecy,nav1)<100.0 then
        SetObjectiveOff(nav1)
        SetObjectiveOn(savhang1)
        SetObjectiveOn(savsupp1)
        goalb=true
    end
    if goala and goalb and not goalc and not IsAlive(savhang1) and not IsAlive(savsupp1) then
        goalc=true
        SetObjectiveOn(nav2)
        ClearObjectives()
        if goalc then
            AddObjective("omegm17C.otf","GREEN")
        else
            AddObjective("omegm17C.otf","WHITE")
        end
        if goale then
            AddObjective("omegm17D.otf","GREEN")
        else
            AddObjective("omegm17D.otf","WHITE")
        end
        if goalg then
            AddObjective("omegm17E.otf","GREEN")
        else
            AddObjective("omegm17E.otf","WHITE")
        end
        AddObjective("omegm17F.otf","WHITE")
        attacker=BuildObject(reinforcement_options[math.random(# reinforcement_options)], 1, "reinforcements_spawn2",0)
        Goto(attacker,ccarecy,0)
        attacker=BuildObject(reinforcement_options[math.random(# reinforcement_options)], 1, "reinforcements_spawn2",1)
        Goto(attacker,ccarecy,0)
        attacker=BuildObject(reinforcement_options[math.random(# reinforcement_options)], 1, "reinforcements_spawn2",2)
        Goto(attacker,ccarecy,0)
        attacker=BuildObject(reinforcement_options[math.random(# reinforcement_options)], 1, "reinforcements_spawn2",3)
        Goto(attacker,ccarecy,0)
        audmsg=AudioMessage("spacer5.wav")
        camerareinforcements=true
        CameraReady()
    end
    
    if goala and goalb and goalc and not goald and goalb and GetDistance(ccarecy,nav2)<100.0 then
        SetObjectiveOff(nav2)
        SetObjectiveOn(savhang2)
        SetObjectiveOn(savsupp2)
        goald=true
    end
    if goala and goalb and goalc and goald and not goale and not IsAlive(savhang2) and not IsAlive(savsupp2) then
        goale=true
        SetObjectiveOn(nav3)
        ClearObjectives()
        if goalc then
            AddObjective("omegm17C.otf","GREEN")
        else
            AddObjective("omegm17C.otf","WHITE")
        end
        if goale then
            AddObjective("omegm17D.otf","GREEN")
        else
            AddObjective("omegm17D.otf","WHITE")
        end
        if goalg then
            AddObjective("omegm17E.otf","GREEN")
        else
            AddObjective("omegm17E.otf","WHITE")
        end
        AddObjective("omegm17F.otf","WHITE")
        attacker=BuildObject(reinforcement_options[math.random(# reinforcement_options)], 1, "reinforcements_spawn3",0)
        Goto(attacker,ccarecy,0)
        attacker=BuildObject(reinforcement_options[math.random(# reinforcement_options)], 1, "reinforcements_spawn3",1)
        Goto(attacker,ccarecy,0)
        audmsg=AudioMessage("spacer5.wav")
        camerareinforcements=true
        CameraReady()
    end
    
    if goala and goalb and goalc and goald and goalc and goale and not goalf and goald and GetDistance(ccarecy,nav3)<100.0 then
        SetObjectiveOff(nav3)
        SetObjectiveOn(savhang3)
        SetObjectiveOn(savsupp3)
        goalf=true
    end
    if goala and goalb and goalc and goald and goalc and goale and goalf and not goalg and not IsAlive(savhang3) and not IsAlive(savsupp3) then
        goalg=true
        SetObjectiveOn(nav4)
        ClearObjectives()
        if goalc then
            AddObjective("omegm17C.otf","GREEN")
        else
            AddObjective("omegm17C.otf","WHITE")
        end
        if goale then
            AddObjective("omegm17D.otf","GREEN")
        else
            AddObjective("omegm17D.otf","WHITE")
        end
        if goalg then
            AddObjective("omegm17E.otf","GREEN")
        else
            AddObjective("omegm17E.otf","WHITE")
        end
        AddObjective("omegm17F.otf","WHITE")
        attacker=BuildObject(reinforcement_options[math.random(# reinforcement_options)], 1, "reinforcements_spawn4",0)
        Goto(attacker,ccarecy,0)
        attacker=BuildObject(reinforcement_options[math.random(# reinforcement_options)], 1, "reinforcements_spawn4",1)
        Goto(attacker,ccarecy,0)
        attacker=BuildObject(reinforcement_options[math.random(# reinforcement_options)], 1, "reinforcements_spawn4",2)
        Goto(attacker,ccarecy,0)
        audmsg=AudioMessage("spacer5.wav")
        camerareinforcements=true
        CameraReady()
    end
    if goala and goalb and goalc and goald and goale and goalf and goalg and not goalh and GetDistance(ccarecy,"home_base")<100.0 then
        goalh=true
        ClearObjectives()
        AddObjective("omegm17B.otf","GREEN")
        AddObjective("omegm17F.otf","GREEN")
        mission_won=true
        audmsg=AudioMessage("spacer5.wav")
    end
    if not IsAlive(ccarecy) and not goali then
        goali=true
        mission_lost=true
        audmsg=AudioMessage("spacer5.wav")
    end
---------------------------------------------------------
--Mission Completion
--
    if mission_won and IsAudioMessageDone(audmsg) then
            SucceedMission(GetTime(),"omegm17w.des")
    end
    
    if mission_lost and IsAudioMessageDone(audmsg) then
            FailMission(GetTime(),"omegm17f.des")
    end
end


