local mission_won=false
local mission_lost=false
local goala=false
local goalb=false
local goalc=false
local goald=false
local goale=false
local goalf=false
local goalg=false
local goalh=false
local startup_done=false
local camera1=false
local camera2=false
local camera3=false
local camera4=false
local camera5=false
local camera6=false



--Resupply Enemy Production Vars
local resupply_period=600.0
local resupply_timer=0.0

local player=nil
local ccarecy=nil
local furyfact=nil
local attacker=nil
local guard1=nil
local guard2=nil
local guard3=nil
local guard4=nil
local guard5=nil

local audmsg=0
local clkmsg=0




function Save()
	return 
		-- bools
		mission_won,mission_lost,goala,goalb,goalc,goald,goale,goalf,goalg,goalh,startup_done,camera1,camera2,camera3,camera4,camera5,camera6,
		-- floats
		resupply_period,resupply_timer,
		-- handles
        player,ccarecy,furyfact,attacker,guard1,guard2,guard3,guard4,guard5,
		-- ints
		audmsg,clkmsg
    end

function Load(...)
	if select('#', ...) > 0 then
		-- bools
		mission_won,mission_lost,goala,goalb,goalc,goald,goale,goalf,goalg,goalh,startup_done,camera1,camera2,camera3,camera4,camera5,camera6,
		-- floats
		resupply_period,resupply_timer,
		-- handles
        player,ccarecy,furyfact,attacker,guard1,guard2,guard3,guard4,guard5,
		-- ints
		audmsg,clkmsg
		= ...
	end
end

function PostLoad()
end



function Update ()

    SetAIP("omegam18.aip", 2)--sets the AIP file for team 3.
    --SetPilot (2, 20) --This gives team 2 20 pilots.
    --SetScrap (2, 50) --This gives team 2 50 scrap.
    player=GetPlayerHandle()
    furyfact=GetHandle("hvmuf0_factory")
    ccarecy=GetHandle("svrecg299_tug")
    guard1=GetHandle("avtank299_wingman")
    guard2=GetHandle("avrckt299_wingman")
    guard3=GetHandle("avfigh299_wingman")
    guard4=GetHandle("svtank299_wingman")
    guard5=GetHandle("svfigh299_wingman")
    
--------------------------------------------------------
--Startup and Camera
--
    if not startup_done then
        startup_done = true
        Goto(ccarecy,"recy_path",1)
        Defend2(guard1,ccarecy,1)
        Defend2(guard2,ccarecy,1)
        Defend2(guard3,ccarecy,1)
        Defend2(guard4,ccarecy,1)
        Defend2(guard5,ccarecy,1)
        camera1=true
        CameraReady()
    end
    
    if camera1 then
		if CameraPath("camera1",1200,400,ccarecy) or CameraCancelled() then
			camera1 = false
			camera2 = true
		end
	end
	
	if camera2 then
		if CameraPath("camera2",2000,1000,furyfact) or CameraCancelled() then
			camera2 = false
			CameraFinish()
			ClearObjectives()
			AddObjective("omegam18.otf","WHITE")
		end
	end
	
	if GetDistance(ccarecy,"destination")<300.0 then
	    RemoveObject(ccarecy)
	    RemoveObject(guard1)
	    RemoveObject(guard2)
	    RemoveObject(guard3)
	    RemoveObject(guard4)
	    RemoveObject(guard5)
	end
	
	if not IsAlive(furyfact) and not goala then
	    ClearObjectives()
	    AddObjective("omegam18.otf","GREEN")
	    audmsg = AudioMessage("spacer5.wav")
        goala = true
        goalb = true
	end
	if goalb and not goalc and IsAudioMessageDone(audmsg) then
	    goalc = true
	    camera3=true
	    CameraReady()
	    audmsg = AudioMessage("spacer5.wav")
	    clkmsg = AudioMessage("cornrclk.wav")
	end
	if camera3 then
	    if CameraObject(player,0.0,200.0,600.0,player) or CameraCancelled() or IsAudioMessageDone(audmsg) then
	        camera3=false
	        camera4=true
	        audmsg = AudioMessage("spacer5.wav")
	        clkmsg = AudioMessage("cornrclk.wav")
	    end
	end
	if camera4 then
	    if CameraObject(player,0.0,1500.0,600.0,player) or CameraCancelled() or IsAudioMessageDone(audmsg) then
	        camera4=false
	        camera5=true
	        audmsg = AudioMessage("spacer5.wav")
	        clkmsg = AudioMessage("cornrclk.wav")
	    end
	end
	if camera5 then
	    if CameraObject(player,0.0,12000.0,600.0,player) or CameraCancelled() or IsAudioMessageDone(audmsg) then
	        camera5=false
	        camera6=true
	        audmsg = AudioMessage("spacer5.wav")
	        clkmsg = AudioMessage("cornrclk.wav")
	    end
	end
	if camera6 then
	    if CameraObject(player,0.0,21000.0,600.0,player) or CameraCancelled() or IsAudioMessageDone(audmsg) then
	        camera6=false
	        mission_won=true
	        clkmsg = AudioMessage("cornrclk.wav")
	    end
	end
        

--------------------------------------------------------	
-- AI Resupply Timer
-- This gives the AI more pilots and scrap periodically.
	if resupply_timer<resupply_period then
        resupply_timer = resupply_timer + 0.0167
        else
        resupply_timer = 0.0
        AddPilot (2, 60) 
        AddScrap (2, 150)
    end
    
---------------------------------------------------------
--Mission Components
--   
    
---------------------------------------------------------
--Mission Completion
--
    if mission_won and IsAudioMessageDone(audmsg) then
            SucceedMission(GetTime(),"omegm18w.des")
    end
    
    if mission_lost and IsAudioMessageDone(audmsg) then
            FailMission(GetTime(),"omegm18f.des")
    end
end


