local mission_won=false
local mission_lost=false
local goala=false
local goalb=false
local goalc=false
local goald=false
local goale=false
local camera1=false
local camera2=false
local camera3=false
local startup_done=false

--local last_wave_time=99999.0
--local wave_timer=0.0
--local cam_time=0.0
--local NextSecond=99999.0
local audmsg=0

local madison=nil
local lpad=nil
local ccarecy=nil
local player=nil
local lpadnav=nil
local shielda=nil
local shieldb=nil
local shieldc=nil
local raxresup=nil
local patrol2a=nil
local patrol2b=nil
local patrol3a=nil
local patrol3b=nil
local patrol3c=nil
local patrol4a=nil
local patrol5a=nil
local patrol5b=nil
local patrol6a=nil
local patrol6b=nil
local patrol7a=nil
local patrol7b=nil
local patrol7c=nil
local reinforce=nil


function Save()
	return 
		-- bools
		mission_won,mission_lost,goala,goalb,goalc,goald,goale,camera1,camera2,camera3,startup_done,
		-- floats
		
		-- handles
        madison,lpad,ccarecy,player,lpadnav,shielda,shieldb,shieldc,raxresup,patrol2a,patrol2b,patrol3a,patrol3c,patrol3b,patrol4a,patrol5a,patrol5b,patrol6a,patrol6b,patrol7a,patrol7b,patrol7c,reinforce,
		-- ints
		audmsg
end

function Load(...)
	if select('#', ...) > 0 then
		-- bools
		mission_won,mission_lost,goala,goalb,goalc,goald,goale,camera1,camera2,camera3,startup_done,
		-- floats
		
		-- handles
        madison,lpad,ccarecy,player,lpadnav,shielda,shieldb,shieldc,raxresup,patrol2a,patrol2b,patrol3a,patrol3c,patrol3b,patrol4a,patrol5a,patrol5b,patrol6a,patrol6b,patrol7a,patrol7b,patrol7c,reinforce,
		-- ints
		audmsg
		= ...
	end
end

function PostLoad()
end


function Update ()
    
    --From Goomba's "template" not sure if it works correctly
    --Ally(3, 4) --This allies team 3 and 4, use this to ally two AI teams.
    SetAIP("omegam02.aip", 2) --sets the AIP file for team 3.
    --SetAIP("mpi1sov.aip", 4) --This sets the AIP file for team 4.
    --SetPilot (2, 20) --This gives team 3 20 pilots.
    --SetScrap (2, 50) --This gives team 3 50 scrap.
    --SetPilot (4, 20) --This gives team 4 20 pilots.
    --SetScrap (4, 50) --This gives team 3 50 scrap.
    
	player = GetPlayerHandle()
	madison = GetHandle("avmuf72_factory")
    lpad = GetHandle("ablpad0_i76building")
	ccarecy = GetHandle("svrecy0_recycler")
	lpadnav = GetHandle("apcamr48_camerapod")
    shielda = GetHandle("sbshld4_i76building")
    shieldb = GetHandle("sbshld2_i76building")
    shieldc = GetHandle("sbshld3_i76building")
    raxresup = GetHandle("sbbarr2_barracks")
    
    Ally(2,3)
 
    if not startup_done then
        startup_done = true
        camera1=true
        CameraReady()
        audmsg = AudioMessage("spacer8.wav")
    end
    
    if camera1 then
		if CameraPath("camera1",1200,1550,madison) or CameraCancelled() then
			camera1 = false
			--cam_time=GetTime()+10.0
			CameraFinish()
			ClearObjectives()
			AddObjective("omegam02.otf", "WHITE")
		end
	end
	
    if not goalb then
        SetTeamNum(lpad,2)
        SetMaxHealth(lpad,99999.0)
        SetCurHealth(lpad,99999.0)
        else
        SetTeamNum(lpad,1)
        SetObjectiveOn(lpad)
    end --controlling launch pad allegance
    
    if not goale then
        goale = true
        SetMaxHealth(shielda,1200)
        SetCurHealth(shielda,1200)
        SetMaxHealth(shieldb,1200)
        SetCurHealth(shieldb,1200)
        SetMaxHealth(shieldc,1200)
        SetCurHealth(shieldc,1200)
    end --inital lowering of shield health
	
	if GetDistance(madison,lpad)<70.0 and not goala then
	    goala = true
	    reinforce = BuildObject("svtank",2,"path_4spawn")
        Attack(reinforce,madison,1)
	    reinforce = BuildObject("svtank",2,"path_4spawn")
        Attack(reinforce,madison,1)
	    reinforce = BuildObject("svfigh",2,"path_4spawn")
        Attack(reinforce,madison,1)
	    reinforce = BuildObject("svfigh",2,"path_4spawn")
        Attack(reinforce,madison,1)
	    reinforce = BuildObject("svfigh",2,"path_4spawn")
        Attack(reinforce,madison,1)
	    reinforce = BuildObject("svfigh",2,"path_4spawn")
        Attack(reinforce,madison,1)        
        if goalb then
            ClearObjectives()
	        AddObjective("omegm02B.otf", "GREEN")
	        AddObjective("omegm02C.otf", "GREEN")
	        AddObjective("omegm02D.otf", "GREEN")
	        audmsg=AudioMessage("spacer8.wav")
	        mission_won = true	        
	        else
	        ClearObjectives()
	        AddObjective("omegm02B.otf", "GREEN")
	        AddObjective("omegm02C.otf", "WHITE")
	        AddObjective("omegm02D.otf", "WHITE")
        end
	end --"If you get to the launch pad first", and creating the attackers to kill you
	
	if not IsValid(madison) and not goalc then
	    goalc = true
	    ClearObjectives()
	    if goala then
	        AddObjective("omegm02B.otf", "GREEN")
	        else
	        AddObjective("omegm02B.otf", "WHITE")
	    end
	    if goalb then
	        AddObjective("omegm02C.otf", "GREEN")
	        else
	        AddObjective("omegm02C.otf", "WHITE")
	   end
	   AddObjective("omegm02D.otf", "RED")
	   mission_lost = true
	   audmsg=AudioMessage("spacer8.wav")
    end --"If the MUF Madison dies"
    
    if not IsValid(shielda) and not IsValid(shieldb) and not IsValid(shieldc)and not goalb then
        goalb = true
        ClearObjectives()
        if goala then
            ClearObjectives()
	        AddObjective("omegm02B.otf", "GREEN")
	        AddObjective("omegm02C.otf", "GREEN")
	        AddObjective("omegm02D.otf", "GREEN")
	        audmsg=AudioMessage("spacer8.wav")
	        mission_won = true	        
	        else
	        ClearObjectives()
	        AddObjective("omegm02B.otf", "WHITE")
	        AddObjective("omegm02C.otf", "GREEN")
	        AddObjective("omegm02D.otf", "WHITE")
        end
    end --"If you kill the shields first"
    
    if GetDistance(madison,"reinforce")<150.0 and not goald then
        goald = true
        reinforce = BuildObject("avtank",1,"path_3spawn")
        Follow(reinforce,madison,0)
       -- reinforce = BuildObject("avfigh",1,"path_3spawn")
       -- Follow(reinforce,madison,0)
       -- reinforce = BuildObject("avtank",1,"path_3spawn")
       -- Follow(reinforce,madison,0)
    end -- Getting reinforcements when you reach the barracks
    
    -- Setting patrols!
    if not IsValid(patrol2a) then
        SetPathLoop("path_2")
        patrol2a = BuildObject("svfigh",2,"path_2spawn")
        Patrol(patrol2a,"path_2",1)
    end

    if not IsValid(patrol2b) then
        SetPathLoop("path_2")
        patrol2b = BuildObject("svfigh",2,"path_2spawn")
        Patrol(patrol2b,"path_2",1)
    end

    if not IsValid(patrol3a) then
        SetPathLoop("path_3")
        patrol3a = BuildObject("svtank",2,"path_3spawn")
        Patrol(patrol3a,"path_3",1)
    end

    if not IsValid(patrol3b) then
        SetPathLoop("path_3")
        patrol3b = BuildObject("svtank",2,"path_3spawn")
        Patrol(patrol3b,"path_3",1)
    end

    if not IsValid(patrol3c) then
        SetPathLoop("path_3")
        patrol3c = BuildObject("svtank",2,"path_3spawn")
        Patrol(patrol3c,"path_3",1)
    end
    
    if not IsValid(patrol4a) then
        SetPathLoop("path_4")
        patrol4a = BuildObject("svtank",2,"path_4spawn")
        Patrol(patrol4a,"path_4",1)
    end
    
    if not IsValid(patrol5a) then
        SetPathLoop("path_5")
        patrol5a = BuildObject("svtank",2,"path_5spawn")
        Patrol(patrol5a,"path_5",1)
    end

    if not IsValid(patrol5b) then
        SetPathLoop("path_5")
        patrol5b = BuildObject("svfigh",2,"path_5spawn")
        Patrol(patrol5b,"path_5",1)
    end

    if not IsValid(patrol6a) then
        SetPathLoop("path_6")
        patrol6a = BuildObject("svfigh",2,"path_6spawn")
        Patrol(patrol6a,"path_6",1)
    end

    if not IsValid(patrol6b) then
        SetPathLoop("path_6")
        patrol6b = BuildObject("svtank",2,"path_6spawn")
        Patrol(patrol6b,"path_6",1)
    end
    
    if not IsValid(patrol7a) then
        SetPathLoop("path_7")
        patrol7a = BuildObject("svfigh",2,"path_7spawn")
        Patrol(patrol7a,"path_7",1)
    end
 
    if not IsValid(patrol7b) then
        SetPathLoop("path_7")
        patrol7b = BuildObject("svfigh",2,"path_7spawn")
        Patrol(patrol7b,"path_7",1)
    end
    
     if not IsValid(patrol7c) then
        SetPathLoop("path_7")
        patrol7c = BuildObject("svfigh",2,"path_7spawn")
        Patrol(patrol7c,"path_7",1)
    end
    --end setting patrols  
    
    if mission_won and IsAudioMessageDone(audmsg) then
            SucceedMission(GetTime(),"omegm02w.des")
    end
    
    if mission_lost and IsAudioMessageDone(audmsg) then
            FailMission(GetTime(),"omegm02f.des")
    end
end


