local mission_won=false
local mission_lost=false
local goala=false
local goalb=false
local goalc=false
local goald=false
local bdesp1=false
local bdesp2=false
local bdesp3=false
local bdesp4=false
local cdesp1=false
local cdesp2=false

--Resupply Enemy Production Vars
local resupply_period=720.0
local resupply_timer=0.0
local AI_start_timer=0.0
local AI_start_period=120.0
local audmsg=0

local desperado1=nil
local desperado2=nil
local desperado3=nil
local desperadotar=nil
local ccarecy2=nil
local ccafact1=nil
local ccarecy1=nil
local ccafact2=nil
local player=nil
local hatfield=nil
local desperatebarr1=nil
local desperatebarr2=nil
local desperatebarr3=nil
local desperatebarr4=nil
local desperatecafe1=nil
local desperatecafe2=nil

function Save()
	return 
		-- bools
		mission_won,mission_lost,goala,goalb,goalc,goald,bdesp1,bdesp2,bdesp3,bdesp4,cdesp1,cdesp2,
		-- floats
		resupply_period,resupply_timer,AI_start_timer,AI_start_period,
		-- handles
        ccarecy1,ccarecy2,ccafact1,ccafact2,player,hatfield,desperatebarr1,desperatebarr2,desperatebarr3,desperatebarr4,desperatecafe1,desperatecafe2,desperado1,desperado2,desperado3,desperadotar,
		-- ints
		audmsg
    end

function Load(...)
	if select('#', ...) > 0 then
		-- bools
		mission_won,mission_lost,goala,goalb,goalc,goald,bdesp1,bdesp2,bdesp3,bdesp4,cdesp1,cdesp2,
		-- floats
		resupply_period,resupply_timer,AI_start_timer,AI_start_period,
		-- handles
        ccarecy1,ccarecy2,ccafact1,ccafact2,player,hatfield,desperatebarr1,desperatebarr2,desperatebarr3,desperatebarr4,desperatecafe1,desperatecafe2,desperado1,desperado2,desperado3,desperadotar,
		-- ints
		audmsg
		= ...
	end
end

function PostLoad()
end



function Update ()

    SetAIP("omegam04.aip", 2)--sets the AIP file for team 3.
    --SetPilot (2, 20) --This gives team 3 20 pilots.
    --SetScrap (2, 50) --This gives team 3 50 scrap.


    
	player = GetPlayerHandle()
    ccarecy1 = GetHandle("svrecy0_recycler")
    ccarecy2 = GetHandle("svrecy211_recycler")
    ccafact1 = GetHandle("svmuf209_factory")
    ccafact2 = GetHandle("svmuf0_factory")
    desperatebarr1 = GetNearestBuilding("barrdesperation1")
    desperatebarr2 = GetNearestBuilding("barrdesperation2")
    desperatebarr3 = GetNearestBuilding("barrdesperation3")
    desperatebarr4 = GetNearestBuilding("barrdesperation4")
    desperatecafe1 = GetNearestBuilding("cafedesperation1")
    desperatecafe2 = GetNearestBuilding("cafedesperation2")

-- Desperation pilot spawns
    if GetDistance(GetNearestEnemy(desperatecafe1),desperatecafe1)<75.0 and not IsAlive(ccarecy1) and not IsAlive(ccafact1) and not cdesp1 then
        desperado1 = BuildObject("sspilo",2,"cafedesperation1")
        desperado2 = BuildObject("sssold",2,"cafedesperation1")
        desperado3 = BuildObject("sspilo",2,"cafedesperation1") 
        desperadotar = GetNearestEnemy(desperatecafe1)
        Attack(desperado1,desperadotar,1)
        Attack(desperado2,desperadotar,1)
        cdesp1 = true
   end
   
   if GetDistance(GetNearestEnemy(desperatecafe2),desperatecafe2)<75.0 and not IsAlive(ccarecy1) and not IsAlive(ccafact1) and not cdesp2 then
        desperado1 = BuildObject("sssold",2,"cafedesperation2")
        desperadotar = GetNearestEnemy(desperatecafe2)
        Attack(desperado1,desperadotar,1)
        cdesp2 = true
   end
    
   if GetDistance(GetNearestEnemy(desperatebarr1),desperatebarr1)<75.0 and not IsAlive(ccarecy1) and not IsAlive(ccafact1) and not bdesp1 then
        desperado1 = BuildObject("sspilo",2,"barrdesperation1")
        desperado2 = BuildObject("sssold",2,"barrdesperation1")
        desperado3 = BuildObject("sspilo",2,"barrdesperation1") 
        desperadotar = GetNearestEnemy(desperatebarr1)
        Attack(desperado1,desperadotar,1)
        Attack(desperado2,desperadotar,1)
        Attack(desperado3,desperadotar,1)
        bdesp1 = true
   end
   
   if GetDistance(GetNearestEnemy(desperatebarr2),desperatebarr2)<50.0 and not IsAlive(ccarecy1) and not IsAlive(ccafact1) and not bdesp2 then
        desperado1 = BuildObject("sspilo",2,"barrdesperation2")
        desperadotar = GetNearestEnemy(desperatebarr2)
        Attack(desperado1,desperadotar,1)
        bdesp2 = true
        
   end 
    
   if GetDistance(GetNearestEnemy(desperatebarr3),desperatebarr3)<20.0 and not IsAlive(ccarecy1) and not IsAlive(ccafact1) and not bdesp3 then
        desperado1 = BuildObject("sssold",2,"barrdesperation3")
        desperadotar = GetNearestEnemy(desperatebarr3)
        Attack(desperado1,desperadotar,1)
        bdesp3 = true   
   end

   if GetDistance(GetNearestEnemy(desperatebarr4),desperatebarr4)<60.0 and not IsAlive(ccarecy1) and not IsAlive(ccafact1) and not bdesp4 then
        desperado1 = BuildObject("sspilo",2,"barrdesperation4")
        desperado2 = BuildObject("sspilo",2,"barrdesperation4")
        desperadotar = GetNearestEnemy(desperatebarr4)
        Attack(desperado1,desperadotar,1)
        Attack(desperado2,desperadotar,1)
        bdesp4 = true   
   end
        
-- AI Start Timer
-- This gives the AI more pilots and scrap periodically.
	if not goalc then
        if AI_start_timer<AI_start_period then
            AI_start_timer = AI_start_timer + 0.0167
            else
            AddPilot (2, 10) 
            AddScrap (2, 140)
            goalc = true
        end
    end   

-- AI Resupply Timer
-- This gives the AI more pilots and scrap periodically.
	if resupply_timer<resupply_period then
        resupply_timer = resupply_timer + 0.0167
        else
        resupply_timer = 0.0
        AddPilot (2, 60) 
        AddScrap (2, 160)
    end
	
	if ((not IsAlive(ccafact1) and not IsAlive(ccarecy1)) or (not IsAlive(ccafact2) and not IsAlive(ccarecy2))) and not goala then
	    goala = true
	    ClearObjectives()
	    AddObjective("omegm04B.otf", "WHITE")
	    AddObjective("omegam04.otf", "WHITE")	
    end   
	
	if not IsAlive(ccafact1) and not IsAlive(ccarecy1) and not IsAlive(ccafact2) and not IsAlive(ccarecy2) and not goalb then
	    goalb = true
	    ClearObjectives()
	    AddObjective("omegam04.otf", "GREEN")
        audmsg=AudioMessage("spacer8.wav")
		mission_won=true    
	end	
	    
    
    if mission_won and IsAudioMessageDone(audmsg) then
            SucceedMission(GetTime(),"omegm04w.des")
    end
    
    if mission_lost and IsAudioMessageDone(audmsg) then
            FailMission(GetTime(),"omegm04f.des")
    end
end


