local mission_won=false
local mission_lost=false
local goala=false
local goalb=false
local goalc=false
local goald=false
local goale=false
local goalf=false
local goalg=false
local goalh=false
local startup_done=false
local camera1=false
local camera2=false
local camera3=false



--Resupply Enemy Production Vars
local resupply_period=600.0
local resupply_timer=0.0
local audmsg=0

local player=nil
local myrecy=nil
local nsdfrecy=nil
local nsdffact=nil
local nsdfarmo=nil
local outpost1=nil
local outpost2=nil
local outpost3=nil
local attacker=nil
local walker1=nil
local walker2=nil
local counterattack1=nil
local counterattack2=nil
local counterattack3=nil
local counterattack4=nil
local counterattack5=nil
local counterattack6=nil
local counterattack7=nil
local radar1=nil
local radar2=nil
local radar3=nil


function Save()
	return 
		-- bools
		mission_won,mission_lost,goala,goalb,goalc,goald,goale,goalf,goalg,goalh,startup_done,camera1,camera2,camera3,
		-- floats
		resupply_period,resupply_timer,
		-- handles
        player,myrecy,nsdfrecy,nsdffact,nsdfarmo,outpost1,outpost2,outpost3,attacker,walker1,walker2,counterattack1,counterattack2,counterattack3,
        counterattack4,counterattack5,counterattack6,counterattack7,radar1,radar2,radar3,
		-- ints
		audmsg
    end

function Load(...)
	if select('#', ...) > 0 then
		-- bools
		mission_won,mission_lost,goala,goalb,goalc,goald,goale,goalf,goalg,goalh,startup_done,camera1,camera2,camera3,
		-- floats
		resupply_period,resupply_timer,
		-- handles
        player,myrecy,nsdfrecy,nsdffact,nsdfarmo,outpost1,outpost2,outpost3,attacker,walker1,walker2,counterattack1,counterattack2,counterattack3,
        counterattack4,counterattack5,counterattack6,counterattack7,radar1,radar2,radar3,
		-- ints
		audmsg
		= ...
	end
end

function PostLoad()
end



function Update ()

    SetAIP("dragonm2.aip", 2)--sets the AIP file for team 3.
    --SetPilot (2, 20) --This gives team 2 20 pilots.
    --SetScrap (2, 50) --This gives team 2 50 scrap.
    player=GetPlayerHandle()
    myrecy=GetHandle("cvlrecy0_recycler")
    nsdfrecy=GetHandle("avrecy96_recycler")
    nsdffact=GetHandle("avmuf464_factory")
    radar1=GetHandle("bbcommd24_commtower")
    radar2=GetHandle("bbcommd25_commtower")
    radar3=GetHandle("bbcommd26_commtower")
    
--------------------------------------------------------
--Startup and Camera
--
    if not startup_done then
        startup_done = true
        SetObjectiveOff(radar1)
        SetObjectiveOff(radar2)
        SetObjectiveOff(radar3)
    end
    

--------------------------------------------------------	
-- AI Resupply Timer
-- This gives the AI more pilots and scrap periodically.
	if resupply_timer<resupply_period then
        resupply_timer = resupply_timer + 0.0167
        else
        resupply_timer = 0.0
        AddPilot (2, 60) 
        AddScrap (2, 100)
    end
    
---------------------------------------------------------
--Mission Components
--   
    if not goala and IsDeployed(myrecy) then
        goala=true
        SetObjectiveOn(radar1)
        SetObjectiveOn(radar2)
        SetObjectiveOn(radar3)
        ClearObjectives()
        if goalb then
            AddObjective("dragon2B.otf","GREEN")
        else
            AddObjective("dragon2B.otf","WHITE")
        end
        if goalc then
            AddObjective("dragon2C.otf","GREEN")
        else
            AddObjective("dragon2C.otf","WHITE")
        end
    end
    
    if not goalb and not IsAlive(radar1) and not IsAlive(radar2) and not IsAlive(radar3) then
        goalb=true
        if not goald then
            counterattack1=BuildObject("avtank",2,"counterattack_spawn",0)
            Goto(counterattack1,"counterattack_goto")
            counterattack2=BuildObject("avtank",2,"counterattack_spawn",1)
            Goto(counterattack2,"counterattack_goto")
            counterattack3=BuildObject("avtank",2,"counterattack_spawn",2)
            Goto(counterattack3,"counterattack_goto")
            counterattack4=BuildObject("avtank",2,"counterattack_spawn",3)
            Goto(counterattack4,"counterattack_goto")
            counterattack5=BuildObject("avtank",2,"counterattack_spawn",4)
            Goto(counterattack5,"counterattack_goto")
            counterattack6=BuildObject("avhraz",2,"counterattack_spawn",5)
            Goto(counterattack6,"counterattack_goto")
            counterattack7=BuildObject("avhraz",2,"counterattack_spawn",6)
            Goto(counterattack7,"counterattack_goto")
            goald=true
        end
        ClearObjectives()
        if goalb then
            AddObjective("dragon2B.otf","GREEN")
        else
            AddObjective("dragon2B.otf","WHITE")
        end
        if goalc then
            AddObjective("dragon2C.otf","GREEN")
        else
            AddObjective("dragon2C.otf","WHITE")
        end
        if not goale then
            AddObjective("dragon2D.otf","YELLOW")
            else
            AddObjective("dragon2D.otf","GREEN")
        end
    end
    if not goalc and not IsAlive(nsdffact) and not IsAlive(nsdfrecy) then
        goalc=true
        if not goald then
            counterattack1=BuildObject("avtank",2,"counterattack_spawn",0)
            Goto(counterattack1,"counterattack_goto")
            counterattack2=BuildObject("avtank",2,"counterattack_spawn",1)
            Goto(counterattack2,"counterattack_goto")
            counterattack3=BuildObject("avtank",2,"counterattack_spawn",2)
            Goto(counterattack3,"counterattack_goto")
            counterattack4=BuildObject("avtank",2,"counterattack_spawn",3)
            Goto(counterattack4,"counterattack_goto")
            counterattack5=BuildObject("avtank",2,"counterattack_spawn",4)
            Goto(counterattack5,"counterattack_goto")
            counterattack6=BuildObject("avhraz",2,"counterattack_spawn",5)
            Goto(counterattack6,"counterattack_goto")
            counterattack7=BuildObject("avhraz",2,"counterattack_spawn",6)
            Goto(counterattack7,"counterattack_goto")
            goald=true
        end
        ClearObjectives()
       if goalb then
            AddObjective("dragon2B.otf","GREEN")
        else
            AddObjective("dragon2B.otf","WHITE")
        end
        if goalc then
            AddObjective("dragon2C.otf","GREEN")
        else
            AddObjective("dragon2C.otf","WHITE")
        end
        if not goale then
            AddObjective("dragon2D.otf","YELLOW")
            else
            AddObjective("dragon2D.otf","GREEN")
        end
    end
    if goalb or goalc then
        if not goale and not IsAlive(counterattack1) and not IsAlive(counterattack2) and not IsAlive(counterattack3)
        and not IsAlive(counterattack4) and not IsAlive(counterattack5) and not IsAlive(counterattack6) and not IsAlive(counterattack7) then
            goale=true
            ClearObjectives()
            if goalb then
                AddObjective("dragon2B.otf","GREEN")
            else
                AddObjective("dragon2B.otf","WHITE")
            end
            if goalc then
                AddObjective("dragon2C.otf","GREEN")
            else
                AddObjective("dragon2C.otf","WHITE")
            end
            if not goale then
                AddObjective("dragon2D.otf","YELLOW")
                else
                AddObjective("dragon2D.otf","GREEN")
            end
        end
    end
    if goalb and goalc and goale and not goalf then
        goalf=true
        audmsg=AudioMessage("spacer5.wav")
        mission_won=true
        ClearObjectives()
        if goalb then
            AddObjective("dragon2B.otf","GREEN")
        else
            AddObjective("dragon2B.otf","WHITE")
        end
        if goalc then
            AddObjective("dragon2C.otf","GREEN")
        else
            AddObjective("dragon2C.otf","WHITE")
        end
        if not goale then
            AddObjective("dragon2D.otf","YELLOW")
            else
            AddObjective("dragon2D.otf","GREEN")
        end
    end
    if not IsAlive(myrecy) and not goalg then
        goalg=true
        audmsg=AudioMessage("spacer5.wav")
        mission_lost=true
        ClearObjectives()
        AddObjective("dragon2B.otf","RED")
        AddObjective("dragon2C.otf","RED")
    end
    if IsAlive(radar1) or IsAlive(radar2) or IsAlive(radar3) then
        if not IsAlive(walker1) then
            walker1=BuildObject("avwalk",2,"walker1_spawn")
            SetPathLoop("walker1_patrol")
            Patrol(walker1,"walker1_patrol")
        end
        if not IsAlive(walker2) then
            walker2=BuildObject("avwalk",2,"walker2_spawn")
            SetPathLoop("walker2_patrol")
            Patrol(walker2,"walker2_patrol")
        end
    end
          
---------------------------------------------------------
--Mission Completion
--
    if mission_won and IsAudioMessageDone(audmsg) then
            SucceedMission(GetTime(),"dragon2w.des")
    end
    
    if mission_lost and IsAudioMessageDone(audmsg) then
            FailMission(GetTime(),"dragon2f.des")
    end
end


