local mission_won=false
local mission_lost=false
local goala=false
local goalb=false
local goalc=false
local goald=false
local goale=false
local goalf=false
local goalg=false
local goalh=false
local startup_done=false
local camera1=false
local camera2=false
local camera3=false
local camera4=false
local camera5=false



--Resupply Enemy Production Vars
local resupply_period=600.0
local resupply_timer=0.0
local fury_period=360.0
local fury_timer=0.0
local audmsg=0

local player=nil
local myrecy=nil
local nsdfrecy=nil
local nsdffact=nil
local nsdfarmo1=nil
local nsdfarmo2=nil
local nsdfarmo3=nil
local attacker=nil
local wrecker1=nil
local wrecker2=nil
local wrecker3=nil
local wrecker4=nil
local wrecker5=nil
local wrecker6=nil
local wrecker7=nil

function Save()
	return 
		-- bools
		mission_won,mission_lost,goala,goalb,goalc,goald,goale,goalf,goalg,goalh,startup_done,camera1,camera2,camera3,camera4,camera5,
		-- floats
		resupply_period,resupply_timer,fury_period,fury_timer,
		-- handles
        player,myrecy,nsdfrecy,nsdffact,nsdfarmo1,nsdfarmo2,nsdfarmo3,attacker,wrecker1,wrecker2,wrecker3,wrecker4,wrecker5,wrecker6,wrecker7,wrecker8,
		-- ints
		audmsg
    end

function Load(...)
	if select('#', ...) > 0 then
		-- bools
		mission_won,mission_lost,goala,goalb,goalc,goald,goale,goalf,goalg,goalh,startup_done,camera1,camera2,camera3,camera4,camera5,
		-- floats
		resupply_period,resupply_timer,fury_period,fury_timer,
		-- handles
        player,myrecy,nsdfrecy,nsdffact,nsdfarmo1,nsdfarmo2,nsdfarmo3,attacker,wrecker1,wrecker2,wrecker3,wrecker4,wrecker5,wrecker6,wrecker7,wrecker8,
		-- ints
		audmsg
		= ...
	end
end

function PostLoad()
end

function Objectives()
    ClearObjectives()
    if goala then
        AddObjective("dragon8B.otf","GREEN")
        else
        AddObjective("dragon8B.otf","WHITE")
    end
    if goalb then
        AddObjective("dragon8C.otf","GREEN")
        else
        AddObjective("dragon8C.otf","WHITE")
    end
    if goalc then
        AddObjective("dragon8D.otf","GREEN")
        else
        AddObjective("dragon8D.otf","WHITE")
    end
end

function Update ()

    SetAIP("dragonm8.aip", 2)--sets the AIP file for team 3.
    --SetPilot (2, 20) --This gives team 2 20 pilots.
    --SetScrap (2, 50) --This gives team 2 50 scrap.
    player=GetPlayerHandle()
    myrecy=GetHandle("cvwrecy13_recyclert")
    nsdfrecy=GetHandle("avrecy0_recycler")
    nsdfarmo1=GetHandle("avslf2_armory")
    nsdfarmo2=GetHandle("avslf1_armory")
    nsdfarmo3=GetHandle("avslf0_armory")
    wrecker1=GetHandle("perwrck131_person")
    wrecker2=GetHandle("perwrck132_person")
    wrecker3=GetHandle("perwrck133_person")
    wrecker4=GetHandle("perwrck134_person")
    wrecker5=GetHandle("perwrck135_person")
    wrecker6=GetHandle("perwrck136_person")
    wrecker7=GetHandle("perwrck137_person")
    wrecker7=GetHandle("perwrck138_person")
    

--------------------------------------------------------
--Startup and Camera
--
    if not startup_done then
        startup_done = true
        camera1=true
        CameraReady()
        audmsg=AudioMessage("spacer5.wav")
        fury_timer=300.0
    end
    
    if camera1 then
		if CameraObject(wrecker1,-200,-700,1400,wrecker1) or CameraCancelled() or IsAudioMessageDone(audmsg) then
			camera1 = false
			camera2 = true
		end
	end
    if camera2 then
		if CameraPath("camera2",600,900,nsdfarmo1) or CameraCancelled() then
			camera2 = false
			CameraFinish()
			Objectives()
		end
	end

--------------------------------------------------------	
-- AI Resupply Timer
-- This gives the AI more pilots and scrap periodically.
	if resupply_timer<resupply_period then
        resupply_timer = resupply_timer + 0.0167
        else
        resupply_timer = 0.0
        AddPilot (2, 60) 
        AddScrap (2, 200)
    end
    
--------------------------------------------------------	
-- Fury Timer
-- 
	if fury_timer<fury_period then
        fury_timer = fury_timer + 0.0167
        else
        fury_timer = 0.0
        SetPathLoop("sav_patrol1")
        SetPathLoop("sav_patrol2")
        attacker=BuildObject("fvsat",3,"sav_spawn1")
        Patrol(attacker,"sav_patrol1",0)
        attacker=BuildObject("fvsat",3,"sav_spawn2")
        Patrol(attacker,"sav_patrol2",0)
        attacker=BuildObject("fvsav",3,"sav_spawn1")
    end    
    
---------------------------------------------------------
--Mission Components
--   
    if not IsAlive(wrecker1) and not IsAlive(wrecker2) and not IsAlive(wrecker3) 
    and not IsAlive(wrecker4) and not IsAlive(wrecker5) and not IsAlive(wrecker6) 
    and not IsAlive(wrecker7) and not IsAlive(wrecker8) and not goala then
        goala=true
        Objectives()
    end
    if not IsAlive(nsdfarmo1) and not IsAlive(nsdfarmo2) and not IsAlive(nsdfarmo3) and not goalb then
        goalb=true
        Objectives()
    end
    if not IsAlive(nsdfrecy) and not goalc then
        goalc=true
        Objectives()
    end
    
    if not IsAlive(myrecy) and not goald then
        goald=true
        ClearObjectives()
        AddObjective("dragonm8.otf","RED")
        audmsg=AudioMessage("spacer5.wav")
        mission_lost=true
    end
    
    if goala and goalb and goalc and not goale then
        goale=true
        Objectives()
        audmsg=AudioMessage("spacer5.wav")
        mission_won=true
    end
    --[[
    if GetDistance(wrecker1,GetNearestEnemy(wrecker1))<50.0 and GetDistance(wrecker1,GetNearestEnemy(wrecker1))>45.0 then
        Attack(wrecker1,GetNearestEnemy(wrecker1))
    end
    if GetDistance(wrecker2,GetNearestEnemy(wrecker2))<50.0 and GetDistance(wrecker2,GetNearestEnemy(wrecker2))>90.0 then
        Attack(wrecker2,GetNearestEnemy(wrecker2))
    end
    if GetDistance(wrecker3,GetNearestEnemy(wrecker3))<50.0 and GetDistance(wrecker3,GetNearestEnemy(wrecker3))>90.0 then
        Attack(wrecker3,GetNearestEnemy(wrecker3))
    end
    if GetDistance(wrecker4,GetNearestEnemy(wrecker4))<100.0 and GetDistance(wrecker4,GetNearestEnemy(wrecker4))>90.0 then
        Attack(wrecker4,GetNearestEnemy(wrecker4))
    end
    if GetDistance(wrecker5,GetNearestEnemy(wrecker5))<100.0 and GetDistance(wrecker5,GetNearestEnemy(wrecker5))>90.0 then
        Attack(wrecker5,GetNearestEnemy(wrecker5))
    end
    if GetDistance(wrecker6,GetNearestEnemy(wrecker6))<100.0 and GetDistance(wrecker6,GetNearestEnemy(wrecker6))>90.0 then
        Attack(wrecker6,GetNearestEnemy(wrecker6))
    end
    if GetDistance(wrecker7,GetNearestEnemy(wrecker7))<100.0 and GetDistance(wrecker7,GetNearestEnemy(wrecker7))>90.0 then
        Attack(wrecker7,GetNearestEnemy(wrecker7))
    end
    if GetDistance(wrecker8,GetNearestEnemy(wrecker8))<100.0 and GetDistance(wrecker8,GetNearestEnemy(wrecker8))>90.0 then
        Attack(wrecker8,GetNearestEnemy(wrecker8))
    end]]
---------------------------------------------------------
--Mission Completion
--
    if mission_won and IsAudioMessageDone(audmsg) then
            SucceedMission(GetTime(),"dragon8w.des")
    end
    
    if mission_lost and IsAudioMessageDone(audmsg) then
            FailMission(GetTime(),"dragon8f.des")
    end
end


