
local mission_won=false
local mission_lost=false
local startup_done=false
local goalb=false
local goalc=false
local goald=false

--Wave Spawn Timer Vars
local wave_period=200.0
local wave_timer=0.0
--Resupply Enemy Production Vars
local resupply_period=360.0
local resupply_timer=0.0
local topoff_period=10.0
local topoff_timer=0.0
--local cam_time=0.0
--local NextSecond=99999.0

local crarecy=nil
local crafact=nil
local player=nil
local apcTable = {}


function AddObject(h)
    if GetTeamNum(h) == 5 and IsOdf(h,"cvapc") then
        for i = 1, # apcTable do
          if not IsAlive(apcTable[i]) then
             table.remove(apcTable, i)
          end
        end
        table.insert(apcTable, h)
    end 
end                   

SetAIControl(5, true)

function Update ()

    SetAIP("strikmpi.aip", 5) 
    Ally (1, 2)
    Ally (1, 3)
    Ally (1, 4)
    Ally (2, 1)
    Ally (2, 3)
    Ally (2, 4)
    Ally (3, 1)
    Ally (3, 2)
    Ally (3, 4)
    Ally (4, 1)
    Ally (4, 2)
    Ally (4, 3)
    UnAlly (5, 1)
    UnAlly (5, 2)
    UnAlly (5, 3)
    UnAlly (5, 4)
    UnAlly (1, 5)
    UnAlly (2, 5)
    UnAlly (3, 5)
    UnAlly (4, 5)
    
    if not startup_done then
        startup_done=true
        AddPilot (5, 50) 
        AddScrap (5, 300)
    end
    player = GetPlayerHandle()
    nsdfrecy = GetHandle("")
    nsdffact = GetHandle("")
    

--------------------------------------------------------------------------------	  
-- AI Resupply Timer
-- This gives the AI more pilots and scrap periodically.
	if resupply_timer<resupply_period then
        resupply_timer = resupply_timer + 0.0167
        else
        resupply_timer = 0.0
        AddPilot (5, 50) 
        AddScrap (5, 225)
    end
    if topoff_timer<topoff_period then
        topoff_timer = topoff_timer + 0.0167
        else
        topoff_timer = 0.0
        if (GetScrap(5) < 20) then AddScrap(5, 1) end
        if (GetPilot(5) < 5) then AddPilot(5, 1) end
    end
    
    for i = 1, # apcTable do
          if IsAlive(apcTable[i]) and GetDistance(apcTable[i],GetNearestEnemy(apcTable[i]))<100.0 and not IsDeployed(apcTable[i]) then
                Deploy(apcTable[i])
          end
    end     
 
    if mission_won and IsAudioMessageDone(audmsg) then
            SucceedMission(GetTime(),"strikebkw.des")
    end
    
    if mission_lost and IsAudioMessageDone(audmsg) then
            FailMission(GetTime(),"strikebkf.des")
    end
end


